//  valac -o "katamiro" --disable-warnings --pkg gee-1.0 --pkg gtk+-3.0 cadenas.gs creapdf.gs comprobacion.gs traduccion.gs  "katamiro.gs"
/*
   Katamotz Ipuinak es software libre : usted puede redistribuirlo y/o modificarlo 
   bajo los términos de la Licencia Pública General GNU publicada 
   por la Fundación para el Software Libre, ya sea la versión 3 
   de la Licencia, o (a su elección) cualquier versión posterior.

   Este programa se distribuye con la esperanza de que sea útil, pero 
   SIN GARANTÍA ALGUNA; ni siquiera la garantía implícita 
   MERCANTIL o de APTITUD PARA UN PROPÓSITO DETERMINADO. 
   Consulte los detalles de la Licencia Pública General GNU para obtener 
   una información más detallada. 

   En el archivo leeme.txt que se distribuye con el programa
   existe una traducción de la Licencia NO OFICIAL Pública General GNU V3 en Español 
   Para consultar la licencia Oficial (valida) on-line en Ingles, consulte <http://www.gnu.org/licenses/>.
*/


uses
	Gtk
	Cairo
	Gee
	GLib.Math

KD:string // Carpeta Katamotz Directorio (Binaries)
UD:string // Carpeta Usuario Directorio (User)
DD:string // Carpeta Datos Directorio (Datos de imagenes)

guardado: bool=false
paginas_png: new list of Gdk.Pixbuf
win: Katamotzipuina
t: Traduccion
init
	KD = "/usr/bin/katamiro"
	//KD = "/home/gontzal/Mahaigaina/katamiro"
	KD=GLib.Environment.get_current_dir ()
	UD= GLib.Environment.get_home_dir ()
	comprueba_directorio_datos()
	DD=GLib.Environment.get_home_dir ()+"/.katamiro" 
	t= new Traduccion("eu") // programa escrito en eu: euskera
	t.traduce() // busca lenguas locales y traduce.
	paginas_png= new list of Gdk.Pixbuf
	Gtk.init(ref args)
	win = new Katamotzipuina()
	Gtk.main()

class imagenes:Object
	imagen: new list of char
	archivo: string
	init
		imagen= new list of char
	
class Ventana_quitafondo: Window 
	imagen: Gdk.Pixbuf
	imagenx: Gdk.Pixbuf
	_padre:Katamotzipuina
	draw_area : DrawingArea
	puntos_x : new list of int
	puntos_y : new list of int
	dibujo: EventBox
	imagen_activa:bool=false
	pixel:uint8*
	_O:int
	caja_general:Paned
	herramienta:string="botepintura"
	cursorbotepintura:Gdk.Pixbuf
	cursorborragoma:Gdk.Pixbuf
	init
		
		title= t.t("Hondoa gardena lortzeko lehioa")
		draw_area = new DrawingArea()
		draw_area.draw.connect(on_expose)
		draw_area.queue_draw_area(0,0,1000,1000)
		dibujo= new EventBox ()
		dibujo.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		dibujo.button_press_event.connect(on_rellena)
		this.set_keep_above(true)
		delete_event.connect(on_salir)
		dibujo.add(draw_area)
		
		var boton_guarda = new Button.with_label(t.t("Salvar"))
		boton_guarda.clicked.connect(on_guarda)
		var boton_borragoma = new Button()
		
		var img_borragoma= new Image.from_file(KD+"/iconos/borragoma.png")
		boton_borragoma.set_image(img_borragoma)
		boton_borragoma.clicked.connect(on_borragoma)
		
		var boton_botepintura = new Button()
		boton_botepintura.clicked.connect(on_botepintura)
		var img_botepintura= new Image.from_file(KD+"/iconos/botepintura.png")
		boton_botepintura.set_image(img_botepintura)
		
		caja_general= new Paned (Gtk.Orientation.VERTICAL)
		var caja_botones= new Box (Gtk.Orientation.HORIZONTAL,5)
		caja_botones.set_homogeneous(true)
		caja_botones.add(boton_guarda)
		caja_botones.add(boton_borragoma)
		caja_botones.add(boton_botepintura)
		
		add(caja_general)
		caja_general.add(dibujo)
		caja_general.add(caja_botones)
		
		caja_general.set_position(500)
		show_all()
		puntos_x = new list of int
		puntos_y = new list of int
		try
			cursorbotepintura= new Gdk.Pixbuf.from_file(KD+"/iconos/botepintura.png")
			cursorborragoma= new Gdk.Pixbuf.from_file(KD+"/iconos/borragoma.png")
			draw_area.get_window().set_cursor(new Gdk.Cursor.from_pixbuf(this.get_display(),cursorbotepintura ,0,0))
		except
			print "imposible leer iconos"
		
		
	construct ( padre:Katamotzipuina)
		_padre=padre
	def on_guarda()
		var m= new MessageDialog(this,DialogFlags.MODAL,MessageType.WARNING,ButtonsType.OK_CANCEL,t.t("Irudian egin duzun aldaketa fitxategian gordeko da betiko."))
		m.response.connect(on_guardando)
		m.show_all()
	def on_guardando(m:Gtk.Dialog , response_id:int )
		if response_id==-5
			// convierte las imagenes en el archivo
			try
				imagen.save (DD+"/Objetos/"+_padre.objetos[_O].archivo, "png") 
			except
				print "error salvando imagen"
			
			//renueva los iconos
			_padre.objetos[_O].icono=imagen.scale_simple (50, 50 , Gdk.InterpType.NEAREST)
			_padre.refresca_elector_objetos(_padre.num_objeto)	
			
						
		m.destroy()
		this.hide()
		
	def on_salir():bool
		this.hide()
		return true
	def on_expose(e : Widget, cr:Context) : bool
		//var cr = Gdk.cairo_create(e.window)
		if imagen_activa
			Gdk.cairo_set_source_pixbuf(cr, imagen, 0, 0) //pinta el escenario
			cr.paint ()
		return true
		
	def inicializa (O:int)
		_O=O
		try
			imagen=new Gdk.Pixbuf.from_file(DD+"/Objetos/"+_padre.objetos[O].archivo)
		except
			print "error"
		this.resize(imagen.get_width(), imagen.get_height()+50)
		caja_general.set_position(imagen.get_height())
		if not imagen.get_has_alpha() do imagen=imagen.add_alpha(false,1,1,1)
		
		imagen_activa=true	
		draw_area.queue_draw_area(0,0,imagen.get_width(), imagen.get_height()) //Refresca la pantalla
		
		
	def getR (x:int,y:int,pixfila:int,canales:int):uchar
		pixel=imagen.get_pixels()
		pixel+= 0+(y * pixfila)+ (x*canales) 	
		return *pixel
		
	def getG (x:int,y:int,pixfila:int,canales:int):uchar
		pixel=imagen.get_pixels()
		pixel+= 1+(y * pixfila)+ (x*canales) 	
		return *pixel
		
	def getB (x:int,y:int,pixfila:int,canales:int):uchar
		pixel=imagen.get_pixels()
		pixel+= 2+(y * pixfila)+ (x*canales) 	
		return *pixel
		
	def getA (x:int,y:int,pixfila:int,canales:int):uchar
		pixel=imagen.get_pixels()
		pixel+= 3+(y * pixfila)+ (x*canales) 	
		return *pixel
		
	def setA (x:int,y:int,pixfila:int,canales:int)
		pixel=imagen.get_pixels()
		pixel+= 3+(y * pixfila)+ (x*canales) 	
		*pixel=0
		
		
	def on_borragoma ()
		herramienta="borragoma"
		draw_area.get_window().set_cursor(new Gdk.Cursor.from_pixbuf( this.get_display(),cursorborragoma ,0,0))
		
	def on_botepintura ()
		herramienta="botepintura"
		draw_area.get_window().set_cursor(new Gdk.Cursor.from_pixbuf(this.get_display(),cursorbotepintura ,0,0))
			
		
	def on_rellena(evento:Gdk.EventButton):bool
		if herramienta=="borragoma"
			x:int
			y:int
			x=(int)evento.x
			y=(int)evento.y
			var canales= imagen.get_n_channels()
			var pixfila= imagen.get_rowstride()
			
			for var i=(x-0) to (x+15)
				for var j=(y-0) to (y+15)
					if (i>=0) and (j>=0) and (j<imagen.get_height()) and (i<imagen.get_width())
						setA(i,j,pixfila,canales)
					
		if herramienta=="botepintura"
			x:int
			y:int
			canales:int
			pixfila:int
			x=(int)evento.x
			y=(int)evento.y
			puntos_x.clear();
			puntos_y.clear();
			puntos_x.add(x);puntos_y.add(y)
			canales= imagen.get_n_channels()
			pixfila= imagen.get_rowstride()		
			var R=getR(x,y,pixfila,canales)
			var G=getG(x,y,pixfila,canales)
			var B=getB(x,y,pixfila,canales)
			var A=getA(x,y,pixfila,canales)
			var cont=0
			while tamano_de_lista(puntos_x)>0 and (cont< imagen.get_height()*imagen.get_width()*2)
				
				var px=puntos_x.last()
				var py=puntos_y.last()
				puntos_x.remove_at(ultimo_de_lista(puntos_x))
				puntos_y.remove_at(ultimo_de_lista(puntos_y))
				var dif=25
				var Rx=getR(px,py,pixfila,canales)   ;var Gx=getG(px,py,pixfila,canales)   ;var Bx=getB(px,py,pixfila,canales);var Ax=getA(px,py,pixfila,canales) 
				
				if (Rx>(R-dif)) and (Gx>(G-dif)) and (Bx>(B-dif)) and (Ax>(A-dif*2)) and (Rx<(R+dif))  and (Gx<(G+dif)) and (Bx<(B+dif)) and (Ax<(A+dif*2))  and (Ax>50)
					
					setA (px,py,pixfila,canales)
					if px-1>=0
						puntos_x.add(px-1); puntos_y.add(py);	
					if px+1<=imagen.get_width()
						puntos_x.add(px+1); puntos_y.add(py);
					if py-1>=0 
						puntos_x.add(px); puntos_y.add(py-1);	
					if py+1<=imagen.get_height() 
						puntos_x.add(px); puntos_y.add(py+1);
			
									
			
		draw_area.queue_draw_area(0,0,imagen.get_width(), imagen.get_height()) //Refresca la pantalla
		_padre.draw_area.queue_draw_area(0,0,_padre.Lienzo_ancho,_padre.Lienzo_alto) //Refresca la pantalla principal
				
		return true
		


class Ventana_Texto : Window
	nuevo_texto: TextView
	caja: Box
	caja_botones:Box
	tamano_texto:Scale
	_padre:Katamotzipuina
	_x:int
	_y:int
	_ancho:int
	_alto:int
	_bocadillo:int
	extension:TextExtents
	txt2:list of string
	texto_modificado:bool=false
	init
		title=t.t("Testua")
		nuevo_texto= new TextView()
		nuevo_texto.wrap_mode=Gtk.WrapMode.WORD  // esto hace que si la letra se agranda no se esconda por el lado derecho
		var boton_introduce = new Button.with_label(t.t("Sartu"))
		boton_introduce.clicked.connect(on_introduce)
		var caja_texto= new Box (Gtk.Orientation.VERTICAL,5)
		tamano_texto= new Scale.with_range (Gtk.Orientation.VERTICAL,30, 60, 1)
		tamano_texto.set_size_request(10,70)
		
		caja_botones= new Box (Gtk.Orientation.HORIZONTAL,5)
		caja_botones.add(boton_introduce)
		caja_botones.add(tamano_texto)
		caja_botones.set_homogeneous(true)
		
		caja_texto.add(nuevo_texto)
		caja_texto.add(caja_botones)
		add(caja_texto)
		
		topex:double=0
		topey:double=0
		set_default_size(400, -1)
		this.set_keep_above(true)
		this.set_modal(true)
		this.set_deletable(false)
		show_all()
		
	construct ( padre:Katamotzipuina)
		_padre=padre
		
	def define_valores(bocadillo:int,x:int,y:int,ancho:int,alto:int)
		var txt=""
		_x=x
		_y=y
		_ancho=ancho
		_alto=alto
		_bocadillo=bocadillo
		nuevo_texto.buffer.set_text("")
		tamano_texto.set_value(_padre.pagina.objetos_activos[bocadillo].tamano_texto)
		if ultimo_de_lista(_padre.pagina.objetos_activos)>=0
			for var i=0 to ultimo_de_lista(_padre.pagina.objetos_activos[bocadillo].texto_original)
				txt+=_padre.pagina.objetos_activos[bocadillo].texto_original[i]+"\n"
			if txt!="\n" and txt!="" 
				txt=txt[0:-1]
				nuevo_texto.buffer.set_text(txt)
		
	def on_introduce()
		_padre.pagina.objetos_activos[_bocadillo].tamano_texto=tamano_texto.get_value()
		_padre.pagina.objetos_activos[_bocadillo].texto_original.clear()
		_padre.pagina.objetos_activos[_bocadillo].texto.clear()
		var txt= this.nuevo_texto.buffer.text
		var lineas= txt.split ("\n")
		for var i=0 to (lineas.length-1)
			_padre.pagina.objetos_activos[_bocadillo].texto.add(lineas[i])
			_padre.pagina.objetos_activos[_bocadillo].texto_original.add(lineas[i])
		_padre.draw_area.queue_draw_area(0,0,_padre.Lienzo_ancho,_padre.Lienzo_alto) //Refresca la pantalla principal
				
		self.hide()

	



class Ventana_nombre_carpeta: Dialog
	nuevo_texto:Entry
	nuevo_nombre:string
	caja: Box
	caja_botones:Box
	respuesta:int
	init
		title=t.t("Idatzi ezazu karpeta berriaren izena")
		nuevo_texto= new Entry()
		add_action_widget (nuevo_texto, respuesta) 
		add_button (Stock.CLOSE, ResponseType.CLOSE);
		add_button (Stock.OK, ResponseType.OK);
		
		this.set_keep_above(true)
		this.set_deletable(false)
		show_all()
		





class Objeto: GLib.Object
	tipo:string=""
	x:int=0
	y:int=0
	ancho:int=0
	alto:int=0
	index: int=0
	profundidad: int=0
	nombre:string=""
	archivo:string=""
	icono: Gdk.Pixbuf=null
	pixbufer: Gdk.Pixbuf=null
	pixbufer_original: Gdk.Pixbuf=null
	ancho_original:int=0
	alto_original:int=0
	tomado_x:int
	tomado_y:int
	Hflip:bool=false
	Vflip:bool=false
	boca_x:int=0
	boca_y:int=0
	bocadillo_tipo:int=0
	colorfondo:int=0
	colorborde:int=0
	colorletra:int=0
	tamano_texto:double=40
	texto: new list of string
	texto_original: new list of string
	init 
		texto= new list of string
		texto_original= new list of string
	
class Pagina:GLib.Object
	objetos_activos: new list of Objeto
	escenario_activo: Objeto
	escenario_es_activo:bool=false
	init
		objetos_activos= new list of Objeto









/////////////////////////////////////////////// Frame principal //////////////////////////////////////////////////////////////////////
class Katamotzipuina : Window
	os: FileOutputStream // para el uso de ficheros
	file: File			 // pare el uso de ficheros
	lista_imagenes: new list of imagenes
	
	ventana_texto:Ventana_Texto
	ventana_nombre_carpeta:Ventana_nombre_carpeta
	ventana_quitafondo: Ventana_quitafondo
	ventana_conversion_pdf: Ventana_conversion_pdf
	
	archivos_tmp: new list of string
	carpeta_ord_objetos: list of string
	carpeta_ord_escenarios: list of string
	carpeta_objetos_activa:int=0
	carpeta_objetos_total:int=0
	carpeta_escenarios_activa:int=0
	carpeta_escenarios_total:int=0
	paginas: new list of Pagina
	ref_produndidad:int=0
	pagina: Pagina
	pagina_activa:int=0
	pagina_kopuru:int=1
	num_escenario:int=0
	num_objeto:int=0
	total_objetos:int=0
	total_escenarios:int=0
	tomado:bool=false
	Boca_tomada:int=-1
	Obj_tomado:int=-1
	Obj_activo:int=-1
	Obj_activo_escalando:bool=false
	nom_tomado:string
	img_x:int=0
	img_y:int=0
	Lienzo_ancho:int=600
	Lienzo_alto:int=500
	cr:Context
	p:ImageSurface
	p2:ImageSurface
	dibujo:EventBox
	
	draw_area:DrawingArea
	objetos: list of Objeto
	Miobjeto: Objeto
	VPanel:Paned
	
	boton_elec_objeto_arriba:Button
	boton_elec_objeto_abajo:Button
	boton_elec_escenario_arriba:Button
	boton_elec_escenario_abajo:Button
	
	escala_elec_objeto:Scale
	escala_elec_escenario:Scale
	
	boton_carpeta_objetos:EventBox
	boton_carpeta_escenarios:EventBox
	label_carpeta_objetos:Label
	label_carpeta_escenarios:Label
	

	boton_borobilhitz:Button
	boton_borobilpentsa:Button
	boton_bocadillo:Button
	boton_cuadro:Button
	boton_eliminar:Button
	boton_flip1:Button
	boton_flip2:Button
	boton_pagizq: Button
	boton_pagder:Button
	boton_insertar:Button
	boton_borrarpag:Button
	boton_topdf:Button
	boton_abrir:Button
	boton_guardar:Button
	boton_sobre:Button
	boton_copia_escenario:Button
	boton_copia_objeto:Button
		
	boton3:Button
	boton4:Button
	
	Caja1:EventBox
	Caja2:EventBox
	Caja3:EventBox
	Caja4:EventBox
	Caja5:EventBox
	Caja6:EventBox
	Caja7:EventBox
	Caja8:EventBox

	Elec_escenario1:Image
	Elec_escenario2:Image
	Elec_escenario3:Image
	Elec_escenario4:Image
	Elec_objeto1:Image
	Elec_objeto2:Image
	Elec_objeto3:Image
	Elec_objeto4:Image
	
	Hcaja:Box
	Hcaja2:Paned
	
	Elec_escenarios_gestioncarp:Box
	Elec_objetos_gestioncarp:Box
	
	Elec_escenarios_gorabehera:Box
	Elec_objetos_gorabehera:Box
	
	Elecciones:Box
	Elec_escenarios: Box
	
	Elec_objetos_img: Box
	Elec_escenarios_img: Box
	
	Elec_escenario_fondos: Box
	Elec_objeto_fondos: Box
	
	Elec_escenario_col: Box
	Elec_objetos_col: Box
	
	CajaEv_esc: list of EventBox
	imagen:Image
	escenarios:list of Objeto
	Srf_escalar: ImageSurface
	Srf_texto: ImageSurface
	no_hay_imagen: Gdk.Pixbuf
	pdn:Gdk.PixbufDestroyNotify
	menuSystem : Gtk.Menu;
									
	init
		lista_imagenes= new list of imagenes
		//carga nombres de carpetas de Escenarios
		var f = FileStream.open(DD+"/carpeta_escenarios","r")
		var a = new array of char[200]
		var bu = new StringBuilder ()
		carpeta_ord_escenarios =new list of string
		carpeta_escenarios_total=-1
		while f.gets(a)!= null
			for s in a do bu.append_c(s)
			carpeta_escenarios_total++
			var cadena=bu.str
			carpeta_ord_escenarios.add(cadena[0:-1])
			bu.erase()
		
		//carga nombres de carpetas de objetos
		f = FileStream.open(DD+"/carpeta_objetos","r")
		carpeta_ord_objetos =new list of string
		carpeta_objetos_total=-1
		while f.gets(a)!= null
			carpeta_objetos_total++
			for s in a do bu.append_c(s)
			var cadena=bu.str
			carpeta_ord_objetos.add(cadena[0:-1])
			bu.erase()
	
		
		archivos_tmp= new list of string
		paginas_png= new list of Gdk.Pixbuf
		paginas= new list of Pagina 
		pagina= new Pagina()
		paginas.add(pagina)
		
		
		escala_elec_escenario= new Scale.with_range (Gtk.Orientation.VERTICAL,0, 1, 1)
		escala_elec_escenario.adjustment.value_changed.connect(on_escala_escenario)
		escala_elec_escenario.set_size_request(20,70)
		escala_elec_objeto= new Scale.with_range (Gtk.Orientation.VERTICAL,0, 1, 1)
		escala_elec_objeto.adjustment.value_changed.connect(on_escala_objeto)
		escala_elec_objeto.set_size_request(20,70)
		var cad= t.t("Katamiro: %s/%s orr")
		title= cad.printf( (pagina_activa+1).to_string(),pagina_kopuru.to_string())
		delete_event.connect(on_salir)
		
		draw_area = new DrawingArea()
		draw_area.draw.connect(on_expose)
		draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
		
		
		dibujo= new EventBox ()
		dibujo.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		dibujo.button_press_event.connect(on_toma)
		
		dibujo.add_events(Gdk.EventMask.BUTTON_RELEASE_MASK)
		dibujo.button_release_event.connect(on_deja)
		
		dibujo.add_events(Gdk.EventMask.POINTER_MOTION_MASK)
		dibujo.motion_notify_event.connect(on_mover)
		dibujo.add(draw_area)
		// imagenes para botones
		try
			no_hay_imagen= new Gdk.Pixbuf.from_file_at_scale(KD+"/iconos/no_hay_imagen.png",50,50,false)
		except
			print "error"
		var img_bocadillo= new Image.from_file (KD+"/iconos/bocadillo.png")
		var img_borobilhitz= new Image.from_file (KD+"/iconos/borobilhitz.png")
		var img_borobilpentsa= new Image.from_file (KD+"/iconos/borobilpentsa.png")
		var img_cuadro= new Image.from_file (KD+"/iconos/cuadro.png")
		var img_arriba= new Image.from_file (KD+"/iconos/go-up.png")
		var img_abajo= new Image.from_file (KD+"/iconos/go-down.png")
		var img_arriba2= new Image.from_file (KD+"/iconos/go-up.png")
		var img_abajo2= new Image.from_file (KD+"/iconos/go-down.png")
		var img_eliminar= new Image.from_file (KD+"/iconos/DooFi_Trash_Bins.png")
		var img_pagizq= new Image.from_file (KD+"/iconos/pagina_atras.png")
		var img_pagder= new Image.from_file (KD+"/iconos/pagina_adelante.png")
		var img_insertar= new Image.from_file (KD+"/iconos/pagina_insertar.png")
		var img_fliphor= new Image.from_file (KD+"/iconos/flip_horizontal.png")
		var img_flipver= new Image.from_file (KD+"/iconos/flip_vertical.png")
		var img_topdf= new Image.from_file (KD+"/iconos/topdf.png")
		var img_abrir= new Image.from_file (KD+"/iconos/fileopen.png")
		var img_guardar= new Image.from_file (KD+"/iconos/filesave.png")
		var img_borrarpag= new Image.from_file (KD+"/iconos/pagina_borrar.png")
		var img_copia_escenario= new Image.from_file (KD+"/iconos/gtk-paste.png")
		var img_copia_objeto= new Image.from_file (KD+"/iconos/gtk-paste.png")
		var img_sobre= new Image.from_file (KD+"/iconos/katamiro.png")
		Srf_escalar= new ImageSurface.from_png (KD+"/iconos/escalar.png")
		Srf_texto= new ImageSurface.from_png (KD+"/iconos/text.png")
		
		
		
		boton_sobre=new Button()
		boton_sobre.set_image(img_sobre)
		boton_sobre.clicked.connect (on_sobre)
		
		boton_bocadillo=new Button()
		boton_bocadillo.set_image(img_bocadillo)
		boton_bocadillo.clicked.connect (on_insertar_bocadillo)
		
		boton_borobilhitz=new Button()
		boton_borobilhitz.set_image(img_borobilhitz)
		boton_borobilhitz.clicked.connect (on_insertar_borobilhitz)
		
		boton_borobilpentsa=new Button()
		boton_borobilpentsa.set_image(img_borobilpentsa)
		boton_borobilpentsa.clicked.connect (on_insertar_borobilpentsa)
		
		boton_cuadro=new Button()
		boton_cuadro.set_image(img_cuadro)
		boton_cuadro.clicked.connect (on_insertar_cuadro)
		
		boton_abrir=new Button()
		boton_abrir.set_image(img_abrir)
		boton_abrir.clicked.connect (on_abrir_proyecto)
		
		boton_guardar=new Button()
		boton_guardar.set_image(img_guardar)
		boton_guardar.clicked.connect (on_guardar_proyecto)
		
		boton_elec_escenario_arriba=new Button()
		boton_elec_escenario_arriba.set_image(img_arriba)
		boton_elec_escenario_arriba.clicked.connect (on_clic_escenario_arriba)
		boton_elec_escenario_arriba.set_size_request(20,70)
		
		boton_elec_escenario_abajo=new Button()
		boton_elec_escenario_abajo.set_image(img_abajo)
		boton_elec_escenario_abajo.clicked.connect (on_clic_escenario_abajo)
		boton_elec_escenario_abajo.set_size_request(20,70)
		
		boton_eliminar=new Button()
		boton_eliminar.set_image(img_eliminar)
		boton_eliminar.clicked.connect(on_eliminar)
		
		boton_flip1=new Button()
		boton_flip1.set_image(img_flipver)
		boton_flip1.clicked.connect(on_flip1)
		
		boton_flip2=new Button()
		boton_flip2.set_image(img_fliphor)
		boton_flip2.clicked.connect(on_flip2)
		
		boton_pagizq= new Button()
		boton_pagizq.set_image(img_pagizq)
		boton_pagizq.clicked.connect(on_pag_izq)
		
		boton_pagder= new Button()
		boton_pagder.set_image(img_pagder)
		boton_pagder.clicked.connect(on_pag_der)
		
		boton_insertar= new Button()
		boton_insertar.set_image(img_insertar)
		boton_insertar.clicked.connect(on_pag_insertar)
		
		boton_borrarpag= new Button()
		boton_borrarpag.set_image(img_borrarpag)
		boton_borrarpag.clicked.connect(on_borrarpag)
		

		boton_topdf= new Button()
		boton_topdf.set_image(img_topdf)
		boton_topdf.clicked.connect(on_exposepdf_2)
		
		boton_copia_escenario= new Button()
		boton_copia_escenario.set_image(img_copia_escenario)
		boton_copia_escenario.clicked.connect(on_copia_escenario)
		
		boton_copia_objeto= new Button()
		boton_copia_objeto.set_image(img_copia_objeto)
		boton_copia_objeto.clicked.connect(on_copia_objeto)
		
		while carpeta_ord_objetos[carpeta_objetos_activa]=="."
			if carpeta_objetos_activa>=carpeta_objetos_total
				carpeta_objetos_activa=0
			else
				carpeta_objetos_activa++
		label_carpeta_objetos= new Label(carpeta_ord_objetos[carpeta_objetos_activa])
		verde:Gdk.RGBA
		verde.parse("Green")
		
		boton_carpeta_objetos=new EventBox()
		boton_carpeta_objetos.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		boton_carpeta_objetos.button_press_event.connect(on_cambia_carpeta_objetos)
		boton_carpeta_objetos.add(label_carpeta_objetos)
		boton_carpeta_objetos.override_background_color(Gtk.StateFlags.NORMAL,verde)
		boton_carpeta_objetos.set_size_request(20,70)
		
		
		while carpeta_ord_escenarios[carpeta_escenarios_activa]=="."
			if carpeta_escenarios_activa>=carpeta_escenarios_total
				carpeta_escenarios_activa=0
			else
				carpeta_escenarios_activa++
				
		label_carpeta_escenarios= new Label (carpeta_ord_escenarios[carpeta_escenarios_activa])
		boton_carpeta_escenarios=new EventBox()
		boton_carpeta_escenarios.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		boton_carpeta_escenarios.button_press_event.connect(on_cambia_carpeta_escenarios)
		boton_carpeta_escenarios.add(label_carpeta_escenarios)
		boton_carpeta_escenarios.override_background_color(Gtk.StateFlags.NORMAL,verde)
		boton_carpeta_escenarios.set_size_request(20,70)
		
		escenarios= new list of Objeto
		refresca_escenarios(carpeta_escenarios_activa)
		objetos=  new list of Objeto
		refresca_objetos(carpeta_objetos_activa)
		
		
		boton_elec_objeto_arriba=new Button()
		boton_elec_objeto_arriba.set_image(img_arriba2)
		boton_elec_objeto_arriba.clicked.connect (on_clic_objeto_arriba)
		boton_elec_objeto_arriba.set_size_request(20,70)
		boton_elec_objeto_abajo=new Button()
		boton_elec_objeto_abajo.set_image(img_abajo2)
		boton_elec_objeto_abajo.clicked.connect (on_clic_objeto_abajo)
		boton_elec_objeto_abajo.set_size_request(20,70)
		
		// crear la columna de fondos para ser elegidos
		Elec_escenario1=new Image.from_pixbuf(no_hay_imagen)
		Caja1= new EventBox()
		Caja1.set_hexpand(true)
		Caja1.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		Caja1.button_press_event.connect(on_clic_escenario1)
		
		Caja1.add(Elec_escenario1)
		
		Elec_escenario2=new Image.from_pixbuf( no_hay_imagen)
		Caja2= new EventBox()
		Caja2.set_hexpand(true)
		Caja2.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		Caja2.button_press_event.connect(on_clic_escenario2)
		Caja2.add(Elec_escenario2)
		
		Elec_escenario3=new Image.from_pixbuf(no_hay_imagen)
		Caja3= new EventBox()
		Caja3.set_hexpand(true)
		Caja3.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		Caja3.button_press_event.connect(on_clic_escenario3)
		Caja3.add(Elec_escenario3)
		
		Elec_escenario4=new Image.from_pixbuf(no_hay_imagen)
		Caja4= new EventBox()
		Caja4.set_hexpand(true)
		Caja4.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		Caja4.button_press_event.connect(on_clic_escenario4)
		Caja4.add(Elec_escenario4)

		// crear la columna de objetos para ser elegidos
		Elec_objeto1=new Image.from_pixbuf(no_hay_imagen)
		Caja5= new EventBox()
		Caja5.set_hexpand(true)
		Caja5.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		Caja5.button_press_event.connect(on_clic_objeto1)
		Caja5.add(Elec_objeto1)
		
		Elec_objeto2=new Image.from_pixbuf( no_hay_imagen)
		
		Caja6= new EventBox()
		Caja6.set_hexpand(true)
		Caja6.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		Caja6.button_press_event.connect(on_clic_objeto2)
		Caja6.add(Elec_objeto2)
		
		Elec_objeto3=new Image.from_pixbuf(no_hay_imagen)
		Caja7= new EventBox()
		Caja7.set_hexpand(true)
		Caja7.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		Caja7.button_press_event.connect(on_clic_objeto3)
		Caja7.add(Elec_objeto3)
		
		Elec_objeto4=new Image.from_pixbuf(no_hay_imagen)
		Caja8= new EventBox()
		Caja8.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		Caja8.button_press_event.connect(on_clic_objeto4)
		Caja8.add(Elec_objeto4)
		
		Elec_escenarios_img= new Box(Gtk.Orientation.VERTICAL,20)
		Elec_escenarios_img.add(Caja1)
		Elec_escenarios_img.add(Caja2)
		Elec_escenarios_img.add(Caja3)
		Elec_escenarios_img.add(Caja4)
		
		Elec_escenario_fondos= new Box(Gtk.Orientation.VERTICAL,5)
		Elec_escenario_fondos.add(Elec_escenarios_img)
		
		Elec_escenarios_gorabehera= new Box(Gtk.Orientation.HORIZONTAL,5)
		Elec_escenarios_gorabehera.set_homogeneous(true)
		Elec_escenarios_gorabehera.add(boton_elec_escenario_arriba)
		Elec_escenarios_gorabehera.add(escala_elec_escenario)
		Elec_escenarios_gorabehera.add(boton_elec_escenario_abajo)

		Elec_objetos_gorabehera= new Box(Gtk.Orientation.HORIZONTAL,5)
		Elec_objetos_gorabehera.set_homogeneous(true)
		Elec_objetos_gorabehera.add(boton_elec_objeto_arriba)
		Elec_objetos_gorabehera.add(escala_elec_objeto)
		Elec_objetos_gorabehera.add(boton_elec_objeto_abajo)

		
		Elec_escenario_col= new Box(Gtk.Orientation.VERTICAL,5)
		Elec_escenario_col.set_vexpand(true)
		Elec_escenario_col.add(boton_carpeta_escenarios)
		Elec_escenario_col.add(Elec_escenarios_gorabehera)
		Elec_escenario_col.add(Elec_escenario_fondos)
		Elec_escenario_col.add(boton_copia_escenario)
		
		Elec_objetos_img= new Box (Gtk.Orientation.VERTICAL,20)
		Elec_objetos_img.add(Caja5)
		Elec_objetos_img.add(Caja6)
		Elec_objetos_img.add(Caja7)
		Elec_objetos_img.add(Caja8)
		
		Elec_objeto_fondos= new Box(Gtk.Orientation.HORIZONTAL,5)
		Elec_objeto_fondos.add(Elec_objetos_img)
		
		Elec_objetos_col= new Box(Gtk.Orientation.VERTICAL,5)
		Elec_objetos_col.set_vexpand(true)		
		Elec_objetos_col.add(boton_carpeta_objetos)
		Elec_objetos_col.add(Elec_objetos_gorabehera)
		Elec_objetos_col.add(Elec_objeto_fondos)
		Elec_objetos_col.add(boton_copia_objeto)
			
		Elecciones= new Box(Gtk.Orientation.HORIZONTAL,5)
		Elecciones.add(Elec_escenario_col)
		Elecciones.add(Elec_objetos_col)
		Elecciones.set_visible(false)
	
		Hcaja2= new Paned (Gtk.Orientation.HORIZONTAL)
		Hcaja2.add (dibujo)
		Hcaja2.add (Elecciones)
		
		Hcaja= new Box(Gtk.Orientation.HORIZONTAL,1)
		Hcaja.set_homogeneous(true)
		Hcaja.add(boton_sobre)
		Hcaja.add(boton_eliminar)
		Hcaja.add(boton_flip1)
		Hcaja.add(boton_flip2)
		Hcaja.add(boton_bocadillo)
		Hcaja.add(boton_borobilhitz)
		Hcaja.add(boton_borobilpentsa)
		Hcaja.add(boton_cuadro)
		Hcaja.add(boton_pagizq)
		Hcaja.add(boton_pagder)
		Hcaja.add(boton_insertar)
		Hcaja.add(boton_borrarpag)
		Hcaja.add(boton_topdf)
		Hcaja.add(boton_abrir)
		Hcaja.add(boton_guardar)		
			
		VPanel= new Paned(Gtk.Orientation.VERTICAL)
		VPanel.add(Hcaja2)
		VPanel.add(Hcaja)
		add(VPanel)
		
		VPanel.set_position(500)
		Hcaja2.set_position(600)
		
		set_default_size(850, 550)
		show_all()
		//activa la ventana de texto pero escondela hasta que sea requerida.
		ventana_nombre_carpeta = new Ventana_nombre_carpeta()
		ventana_nombre_carpeta.hide()
		
		ventana_texto = new Ventana_Texto(this)
		ventana_texto.hide()
		ventana_texto.set_transient_for(this)
		ventana_texto.set_modal(true)
	
		ventana_quitafondo= new  Ventana_quitafondo (this)
		ventana_quitafondo.hide()
		ventana_quitafondo.set_transient_for(this)
		ventana_quitafondo.set_modal(true)
	
		ventana_conversion_pdf= new Ventana_conversion_pdf(this)
		ventana_conversion_pdf.hide()
		ventana_conversion_pdf.set_transient_for(this)
		ventana_conversion_pdf.set_modal(true)
	
		
		refresca_elector_escenarios(num_escenario)
		refresca_elector_objetos(num_objeto)
		if self.total_objetos<=4 do self.escala_elec_objeto.hide()
		if self.total_escenarios<=4 do self.escala_elec_escenario.hide()
	
	///////////////////////////////////////// comienzan las funciones de eventos sobre el panel derecho
	def refresca_elector_objetos(num_objeto:int)
		if num_objeto<total_objetos
			Elec_objeto1.set_from_pixbuf(objetos[(num_objeto)].icono)
		else
			Elec_objeto1.set_from_pixbuf(no_hay_imagen)
			
		if (num_objeto+1)<total_objetos
			Elec_objeto2.set_from_pixbuf(objetos[(num_objeto+1)].icono)
		else
			Elec_objeto2.set_from_pixbuf(no_hay_imagen)
		if (num_objeto+2)<total_objetos
			Elec_objeto3.set_from_pixbuf(objetos[(num_objeto+2)].icono)
		else
			Elec_objeto3.set_from_pixbuf(no_hay_imagen)
		if (num_objeto+3)<total_objetos
			Elec_objeto4.set_from_pixbuf(objetos[(num_objeto+3)].icono)
		else
			Elec_objeto4.set_from_pixbuf(no_hay_imagen)
		
	def refresca_elector_escenarios(num_escenario:int)
		if num_escenario<total_escenarios
			Elec_escenario1.set_from_pixbuf(escenarios[(num_escenario)].icono)
		else
			Elec_escenario1.set_from_pixbuf(no_hay_imagen)
			
		if (num_escenario+1)<total_escenarios
			Elec_escenario2.set_from_pixbuf(escenarios[(num_escenario+1)].icono)
		else
			Elec_escenario2.set_from_pixbuf(no_hay_imagen)
		if (num_escenario+2)<total_escenarios
			Elec_escenario3.set_from_pixbuf(escenarios[(num_escenario+2)].icono)
		else
			Elec_escenario3.set_from_pixbuf(no_hay_imagen)
		if (num_escenario+3)<total_escenarios
			Elec_escenario4.set_from_pixbuf(escenarios[(num_escenario+3)].icono)
		else
			Elec_escenario4.set_from_pixbuf(no_hay_imagen)
	
	def on_escala_escenario() //la escala para moverse entre escenarios
		refresca_elector_escenarios((int)escala_elec_escenario.adjustment.value)
		num_escenario=((int)escala_elec_escenario.adjustment.value)
		
	def on_escala_objeto()//la escala para moverse entre objetos
		refresca_elector_objetos((int)escala_elec_objeto.adjustment.value)
		num_objeto=((int)escala_elec_objeto.adjustment.value)
		
	def on_cambia_carpeta_objetos(evento:Gdk.EventButton):bool
		case evento.button
			when 1
				if carpeta_objetos_activa>=carpeta_objetos_total
					carpeta_objetos_activa=0
				else
					carpeta_objetos_activa++
					
				while carpeta_ord_objetos[carpeta_objetos_activa]=="."
					if carpeta_objetos_activa>=carpeta_objetos_total
						carpeta_objetos_activa=0
					else
						carpeta_objetos_activa++
				
				label_carpeta_objetos.set_label(carpeta_ord_objetos[carpeta_objetos_activa])
				objetos.clear()
				refresca_objetos(carpeta_objetos_activa)
				num_objeto=0
				refresca_elector_objetos(num_objeto)
			when 3
				menuSystem = new Gtk.Menu();
				
				var menuDelete = new ImageMenuItem.from_stock(Stock.DELETE, null);
				menuDelete.activate.connect(on_borrar_carpeta_objetos )
				menuSystem.append(menuDelete);
				var menuInsert = new ImageMenuItem.from_stock(Stock.ADD, null);
				menuInsert.activate.connect(on_insertar_carpeta_objetos )
				menuSystem.append(menuInsert);
				var menuRename = new ImageMenuItem.from_stock(Stock.CONVERT, null);
				menuRename.activate.connect(on_renombrar_carpeta_objetos )
				menuSystem.append(menuRename);
				menuSystem.show_all();				
				menuSystem.popup( null,null,null,0,get_current_event_time () )
				
		return true


	def on_cambia_carpeta_escenarios(evento:Gdk.EventButton):bool	
		case evento.button
			when 1
				if carpeta_escenarios_activa>=carpeta_escenarios_total
					carpeta_escenarios_activa=0
				else
					carpeta_escenarios_activa++
					
				while carpeta_ord_escenarios[carpeta_escenarios_activa]=="."
					if carpeta_escenarios_activa>=carpeta_escenarios_total
						carpeta_escenarios_activa=0
					else
						carpeta_escenarios_activa++
				
				label_carpeta_escenarios.set_label(carpeta_ord_escenarios[carpeta_escenarios_activa])

				escenarios.clear()
				refresca_escenarios(carpeta_escenarios_activa)
				num_escenario=0
				refresca_elector_escenarios(num_escenario)
			when 3
				menuSystem = new Gtk.Menu();
				var menuDelete = new ImageMenuItem.from_stock(Stock.DELETE, null);
				menuDelete.activate.connect(on_borrar_carpeta_escenarios )
				menuSystem.append(menuDelete);
				menuSystem.show_all();
				
				var menuInsert = new ImageMenuItem.from_stock(Stock.ADD, null);
				menuInsert.activate.connect(on_insertar_carpeta_escenarios )
				menuSystem.append(menuInsert);
				menuSystem.show_all();

				var menuRename = new ImageMenuItem.from_stock(Stock.CONVERT, null);
				menuRename.activate.connect(on_renombrar_carpeta_escenarios )
				menuSystem.append(menuRename);
				menuSystem.show_all();
				menuSystem.popup( null,null,null,0,get_current_event_time () )
				
				
		return true


	def on_renombrar_carpeta_escenarios()
		ventana_nombre_carpeta.set_modal(true)
		ventana_nombre_carpeta.nuevo_texto.set_max_length(8)
		ventana_nombre_carpeta.nuevo_texto.set_text("")
		
		case ventana_nombre_carpeta.run()
			when Gtk.ResponseType.CLOSE
				ventana_nombre_carpeta.hide()
				
			when Gtk.ResponseType.OK
				ventana_nombre_carpeta.hide()
				
				carpeta_ord_escenarios.remove_at (carpeta_escenarios_activa)
				carpeta_ord_escenarios.insert (carpeta_escenarios_activa,ventana_nombre_carpeta.nuevo_texto.get_text())
				
				//reescribre el archivo con las nuevas modificaciones.
				var f = FileStream.open(DD+"/carpeta_escenarios","w")
				for var i=0 to carpeta_escenarios_total
					var e= carpeta_ord_escenarios[i]
					f.printf ("%s\n", e  )
				
				while carpeta_ord_escenarios[carpeta_escenarios_activa]=="."
					if carpeta_escenarios_activa>=carpeta_escenarios_total
						carpeta_escenarios_activa=0
					else
						carpeta_escenarios_activa++
				label_carpeta_escenarios.set_label(carpeta_ord_escenarios[carpeta_escenarios_activa])
				escenarios.clear()
				refresca_escenarios(carpeta_escenarios_activa)
				num_escenario=0
				refresca_elector_escenarios(num_escenario)
		
	def on_renombrar_carpeta_objetos()
		ventana_nombre_carpeta.set_modal(true)
		ventana_nombre_carpeta.nuevo_texto.set_max_length(8)
		ventana_nombre_carpeta.nuevo_texto.set_text("")
		
		case ventana_nombre_carpeta.run()
			when Gtk.ResponseType.CLOSE
				ventana_nombre_carpeta.hide()
				
			when Gtk.ResponseType.OK
				ventana_nombre_carpeta.hide()
				
				carpeta_ord_objetos.remove_at (carpeta_objetos_activa)
				carpeta_ord_objetos.insert (carpeta_objetos_activa,ventana_nombre_carpeta.nuevo_texto.get_text())
				
				//reescribre el archivo con las nuevas modificaciones.
				var f = FileStream.open(DD+"/carpeta_objetos","w")
				for var i=0 to carpeta_objetos_total
					var e= carpeta_ord_objetos[i]
					f.printf ("%s\n", e  )
				
				while carpeta_ord_objetos[carpeta_objetos_activa]=="."
					if carpeta_objetos_activa>=carpeta_objetos_total
						carpeta_objetos_activa=0
					else
						carpeta_objetos_activa++
				label_carpeta_objetos.set_label(carpeta_ord_objetos[carpeta_objetos_activa])
				objetos.clear()
				refresca_objetos(carpeta_objetos_activa)
				num_objeto=0
				refresca_elector_objetos(num_objeto)
				
				
	def on_borrar_carpeta_objetos()
		for var i=0 to ultimo_de_lista(objetos)
			var e=objetos[i]
			GLib.FileUtils.rename(DD+"/Objetos/"+e.archivo, DD+"/Objetos/--"+e.archivo[2:e.archivo.length] )
			print e.archivo

		carpeta_ord_objetos.remove_at (carpeta_objetos_activa)
		carpeta_ord_objetos.insert (carpeta_objetos_activa,".")
		
		//reescribre el archivo con las nuevas modificaciones.
		var f = FileStream.open(DD+"/carpeta_objetos","w")
		for var i=0 to carpeta_objetos_total
			var e= carpeta_ord_objetos[i]
			f.printf ("%s\n", e  )
		
		while carpeta_ord_objetos[carpeta_objetos_activa]=="."
			if carpeta_objetos_activa>=carpeta_objetos_total
				carpeta_objetos_activa=0
			else
				carpeta_objetos_activa++
		label_carpeta_objetos.set_label(carpeta_ord_objetos[carpeta_objetos_activa])
		objetos.clear()
		refresca_objetos(carpeta_objetos_activa)
		num_objeto=0
		refresca_elector_objetos(num_objeto)

		
	def on_borrar_carpeta_escenarios()
		for var i=0 to ultimo_de_lista(escenarios)
			var e=escenarios[i]
			GLib.FileUtils.rename(DD+"/Escenarios/"+e.archivo, DD+"/Escenarios/--"+e.archivo[2:e.archivo.length] )
			print e.archivo

		carpeta_ord_escenarios.remove_at (carpeta_escenarios_activa)
		carpeta_ord_escenarios.insert (carpeta_escenarios_activa,".")
		
		//reescribre el archivo con las nuevas modificaciones.
		var f = FileStream.open(DD+"/carpeta_escenarios","w")
		for var i=0 to carpeta_escenarios_total
			var e= carpeta_ord_escenarios[i]
			f.printf ("%s\n", e  )
		
		while carpeta_ord_escenarios[carpeta_escenarios_activa]=="."
			if carpeta_escenarios_activa>=carpeta_escenarios_total
				carpeta_escenarios_activa=0
			else
				carpeta_escenarios_activa++
		
		label_carpeta_escenarios.set_label(carpeta_ord_escenarios[carpeta_escenarios_activa])
		escenarios.clear()
		refresca_escenarios(carpeta_escenarios_activa)
		num_escenario=0
		refresca_elector_escenarios(num_escenario)
		
	
	def on_insertar_carpeta_objetos()
		ventana_nombre_carpeta.set_modal(true)
		ventana_nombre_carpeta.nuevo_texto.set_max_length(8)
		ventana_nombre_carpeta.nuevo_texto.set_text("")
		
		case ventana_nombre_carpeta.run()
			when Gtk.ResponseType.CLOSE
				ventana_nombre_carpeta.hide()
				
			when Gtk.ResponseType.OK
				ventana_nombre_carpeta.hide()
				var insertado=false
				for var i=0 to carpeta_objetos_total
					var e= carpeta_ord_objetos[i]
					if e=="."
						carpeta_ord_objetos[i] =ventana_nombre_carpeta.nuevo_texto.get_text()
						carpeta_objetos_activa=i
						insertado=true
						break
				if not insertado 
					carpeta_ord_escenarios.add(ventana_nombre_carpeta.nuevo_texto.get_text())
					carpeta_objetos_total++
				//reescribre el archivo con las nuevas modificaciones.
				var f = FileStream.open(DD+"/carpeta_objetos","w")
				for var i=0 to carpeta_objetos_total
					var e= carpeta_ord_objetos[i]
					f.printf ("%s\n", e  )
				
				while carpeta_ord_objetos[carpeta_objetos_activa]=="."
					if carpeta_objetos_activa>=carpeta_objetos_total
						carpeta_objetos_activa=0
					else
						carpeta_objetos_activa++
						
				label_carpeta_objetos.set_label(carpeta_ord_objetos[carpeta_objetos_activa])
				objetos.clear()
				refresca_objetos(carpeta_objetos_activa)
				num_objeto=0
				refresca_elector_objetos(num_objeto)
				
		
	def on_insertar_carpeta_escenarios()
		ventana_nombre_carpeta.set_modal(true)
		ventana_nombre_carpeta.nuevo_texto.set_max_length(8)
		ventana_nombre_carpeta.nuevo_texto.set_text("")
		case ventana_nombre_carpeta.run()
			when Gtk.ResponseType.CLOSE
				ventana_nombre_carpeta.hide()
				
			when Gtk.ResponseType.OK
				ventana_nombre_carpeta.hide()	
				var insertado=false
				for var i=0 to carpeta_escenarios_total
					var e= carpeta_ord_escenarios[i]
					if e=="."
						carpeta_ord_escenarios[i] =ventana_nombre_carpeta.nuevo_texto.get_text()
						carpeta_escenarios_activa=i
						insertado=true 
						break
				if not insertado 
					carpeta_ord_escenarios.add(ventana_nombre_carpeta.nuevo_texto.get_text())
					carpeta_escenarios_total++
				//reescribre el archivo con las nuevas modificaciones.
				var f = FileStream.open(DD+"/carpeta_escenarios","w")
				for var i=0 to carpeta_escenarios_total
					var e= carpeta_ord_escenarios[i]
					f.printf ("%s\n", e  )
				
				while carpeta_ord_escenarios[carpeta_escenarios_activa]=="."
					if carpeta_escenarios_activa>=carpeta_escenarios_total
						carpeta_escenarios_activa=0
					else
						carpeta_escenarios_activa++
						
				label_carpeta_escenarios.set_label(carpeta_ord_escenarios[carpeta_escenarios_activa])
				escenarios.clear()
				refresca_escenarios(carpeta_escenarios_activa)
				num_escenario=0
				refresca_elector_escenarios(num_escenario)
				
	
	
	def refresca_objetos(n:int)
		try
			var name="" 
			var d = Dir.open( DD+"/Objetos" )
			var num=""
			total_objetos=0
			while ((name = d.read_name()) != null)
				if name[0:2]== tostring(2,n)
					total_objetos++
					Miobjeto= new Objeto()
					Miobjeto.archivo=name
					num=name[3:6]
					Miobjeto.index=int.parse(num)
					Miobjeto.tipo="Objeto"
					Miobjeto.profundidad=0
					Miobjeto.icono=new Gdk.Pixbuf.from_file_at_scale(DD+"/Objetos/"+name,50,50,false)
					Miobjeto.pixbufer=new Gdk.Pixbuf.from_file(DD+"/Objetos/"+name)
					Miobjeto.alto=Miobjeto.pixbufer.get_height ()
					Miobjeto.ancho= Miobjeto.pixbufer.get_width()
					Miobjeto.alto_original=Miobjeto.pixbufer.get_height ()
					Miobjeto.ancho_original= Miobjeto.pixbufer.get_width()
					Miobjeto.pixbufer=null
					objetos.add(Miobjeto)
			if total_objetos>4
				escala_elec_objeto.show()
				escala_elec_objeto.set_range(0,total_objetos-4)
				
			else
				escala_elec_objeto.hide()
			
		except
			print"no pudo leerse correctamente los objetos"
		
	def refresca_escenarios (n:int)
		try
			var name="" 
			var num=""
			var d = Dir.open( DD+"/Escenarios" )
			total_escenarios=0
			while ( (name = d.read_name()) != null)
				if name[0:2]== tostring(2,n)
					total_escenarios++
					Miobjeto= new Objeto()
					Miobjeto.archivo=name
					num=name[3:6]
					Miobjeto.index=int.parse(num)
					Miobjeto.tipo="Escenario"
					Miobjeto.profundidad=0
					Miobjeto.icono=new Gdk.Pixbuf.from_file_at_scale(DD+"/Escenarios/"+name,100,50,false)
					escenarios.add(Miobjeto)
			if total_escenarios>4
				escala_elec_escenario.show()
				escala_elec_escenario.set_range(0,total_escenarios-4)
			else
				escala_elec_escenario.hide()
		except
			print"no pudo leerse correctamente los Escenarios"
	
		
			
	def on_copia_escenario(b:Button)
		//detectar el numero de escenario que falta entre los archivos de la carpeta de Escenarios
		var esta=false
		var n=0
		var num=-1
		var num_str=""
		for var num_falta=0 to (tamano_de_lista(escenarios)) //el ultimo numero es un escenario que no existe.
			esta=false
			n=0
			while n<=ultimo_de_lista(escenarios)
				if escenarios[n].index==num_falta do esta=true
				n++
			if not esta
				num= num_falta
				break
		num_str=tostring(3,num)

		var display = self.get_display()
		var atom = Gdk.SELECTION_CLIPBOARD;
		var clipboard = Gtk.Clipboard.get_for_display(display,atom)
		var pix = clipboard.wait_for_image();
		if pix!=null
			pix=pix.scale_simple (600, 500 , Gdk.InterpType.NEAREST)
			try
				pix.save(DD+"/Escenarios/"+tostring(2,carpeta_escenarios_activa)+"_"+num_str+".png","png")
			except
				print "error"
			escenarios.clear()
			refresca_escenarios(carpeta_escenarios_activa)
			refresca_elector_escenarios(num_escenario)
			for var i=0 to (ultimo_de_lista(escenarios))
				if escenarios[i].archivo==carpeta_escenarios_activa.to_string()+"_"+num_str+".png"
					paginas[pagina_activa].escenario_activo=escenarios[i]
					paginas[pagina_activa].escenario_activo.pixbufer=pix
					paginas[pagina_activa].escenario_activo.pixbufer_original=pix
					paginas[pagina_activa].escenario_es_activo=true
			draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
	
	def on_copia_objeto(b:Button)
		//detectar el numero de escenario que falta entre los archivos de la carpeta de Escenarios
		var esta=false
		var n=0
		var num=-1
		var num_str=""
		for var num_falta=0 to (tamano_de_lista(objetos)) //el ultimo numero es un escenario que no existe.
			esta=false
			n=0
			while n<=ultimo_de_lista(objetos)
				if objetos[n].index==num_falta do esta=true
				n++
			if not esta
				num= num_falta
				break
		num_str=tostring(3,num)
		
		var displaya = self.get_display()
		var atom = Gdk.SELECTION_CLIPBOARD;
		var clipboard = Gtk.Clipboard.get_for_display(displaya,atom)
		var pix = clipboard.wait_for_image();
		if pix!=null
			pix=pix.scale_simple (300, 300 , Gdk.InterpType.NEAREST)
			try
				pix.save(DD+"/Objetos/"+tostring(2,carpeta_objetos_activa)+"-"+num_str+".png","png")
			except
				print "error"
			objetos.clear()
			refresca_objetos(carpeta_objetos_activa)
			refresca_elector_objetos(num_objeto)
			
			
			//introduce en la pizarra el nuevo objeto del portapapeles.
			for var i=0 to (ultimo_de_lista(objetos))
				if objetos[i].archivo==tostring(2,carpeta_objetos_activa)+"-"+num_str+".png"
					
					
					Miobjeto= new Objeto
					clona(ref Miobjeto,objetos[i])
					name=Miobjeto.archivo
					try
						Miobjeto.pixbufer=new Gdk.Pixbuf.from_file(DD+"/Objetos/"+name)
						Miobjeto.pixbufer_original=new Gdk.Pixbuf.from_file(DD+"/Objetos/"+name)
					except
						print "error"
					paginas[pagina_activa].objetos_activos.add(Miobjeto)
					Obj_activo=ultimo_de_lista(pagina.objetos_activos)
					Obj_activo=ultimo_de_lista(paginas[pagina_activa].objetos_activos)
					
			draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
	
	def on_clic_escenario_arriba (b:Button)
		if num_escenario>0 
			num_escenario--
			refresca_elector_escenarios(num_escenario)
	def on_clic_escenario_abajo (b:Button)
		if (num_escenario<(ultimo_de_lista (escenarios)-3))
			num_escenario++
			refresca_elector_escenarios(num_escenario)			
		
			
		
	def on_clic_objeto_arriba (b:Button)
		if num_objeto>0 
			num_objeto--
			refresca_elector_objetos(num_objeto)			
		
		
	def on_clic_objeto_abajo (b:Button)
		if (num_objeto<(ultimo_de_lista (objetos)-3))
			num_objeto++
			refresca_elector_objetos(num_objeto)
	
	// botones inferiores........................................................ botones inferiores
	
	
	def on_sobre()
		w:Window= new Window()
		l:Label= new Label("Katamiro is Free Software 2013.Licence GNU GPL v3 \nDeveloped with Genie-Vala. \nProgramador: Gontzal Uriarte Gómez. <txasatonga@gmail.com> \nIlustraciones del tema piratas:Aritz Gallastegui Uriarte. <aritzgallas@hotmail.com>")
		
		box_general: Box= new Box(Gtk.Orientation.VERTICAL,5)
		box_imagenes: Box= new Box(Gtk.Orientation.HORIZONTAL,5)
		gontzal:Image =new Image.from_file(KD+"/iconos/gontzal.jpg")
		gontzal.show()
		box_general.add(l)
		box_general.add(box_imagenes)
		box_imagenes.add(gontzal)
		w.add(box_general)
		w.move(100,100)
		w.show_all()
	def on_insertar_bocadillo()
		guardado=false; 
		Miobjeto= new Objeto()
		Miobjeto.tipo="Bocadillo"
		Miobjeto.profundidad=0
		Miobjeto.x=0
		Miobjeto.y=0
		Miobjeto.alto=70
		Miobjeto.ancho=250
		Miobjeto.boca_x=Miobjeto.x+Miobjeto.ancho+30
		Miobjeto.boca_y=Miobjeto.y+(int)(Miobjeto.alto/2)
		
		pagina.objetos_activos.add (Miobjeto)
		Obj_activo=ultimo_de_lista(pagina.objetos_activos)
		draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
		
	def on_insertar_borobilhitz()
		guardado=false; 
		Miobjeto= new Objeto()
		Miobjeto.tipo="Borobilhitz"
		Miobjeto.profundidad=0
		Miobjeto.x=0
		Miobjeto.y=0
		Miobjeto.alto=70
		Miobjeto.ancho=250
		Miobjeto.boca_x=Miobjeto.x+Miobjeto.ancho+50
		Miobjeto.boca_y=Miobjeto.y+Miobjeto.alto+50
		
		pagina.objetos_activos.add (Miobjeto)
		Obj_activo=ultimo_de_lista(pagina.objetos_activos)
		draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
	
	def on_insertar_borobilpentsa()
		guardado=false; 
		Miobjeto= new Objeto()
		Miobjeto.tipo="Borobilpentsa"
		Miobjeto.profundidad=0
		Miobjeto.x=0
		Miobjeto.y=0
		Miobjeto.alto=70
		Miobjeto.ancho=250
		Miobjeto.boca_x=Miobjeto.x+Miobjeto.ancho+70
		Miobjeto.boca_y=Miobjeto.y+Miobjeto.alto+50
		
		pagina.objetos_activos.add (Miobjeto)
		Obj_activo=ultimo_de_lista(pagina.objetos_activos)
		draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
	
	def on_pag_insertar(b:Button)
		ventana_texto.hide()
		ventana_texto.nuevo_texto.buffer.text=""
		paginas[pagina_activa]=pagina // guarda lo que hay hasta ahora
		pagina=new Pagina()  // preparamos la nueva página
		guardado=false  
		paginas.insert(pagina_activa, pagina)
		pagina.escenario_es_activo=false
		pagina_kopuru++
		Obj_activo=-1
		
		var cad="Katamiro: %s/%s orr"
		title=cad.printf((pagina_activa+1).to_string(),pagina_kopuru.to_string())
		draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
	
	
	def on_pag_der (b:Button)
		
		ventana_texto.hide()
		ventana_texto.nuevo_texto.buffer.text=""
		paginas[pagina_activa]=pagina
		pagina_activa++
		pagina=new Pagina()
		if (pagina_activa+1)>pagina_kopuru
			guardado=false; 
			paginas.add(pagina)
			pagina.escenario_es_activo=false
			pagina_kopuru++
			Obj_activo=-1
		else
			pagina=paginas[pagina_activa]
		if ultimo_de_lista(pagina.objetos_activos)>=0
			Obj_activo=ultimo_de_lista (pagina.objetos_activos)
		else 
			Obj_activo=-1
		
		var cad="Katamiro: %s/%s orr"
		title=cad.printf((pagina_activa+1).to_string(),pagina_kopuru.to_string())
		draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
	
	
	def on_salir():bool
		// preguntar si esta seguro!			
		if not guardado
			var m= new MessageDialog(this,DialogFlags.MODAL,MessageType.WARNING,ButtonsType.YES_NO,t.t("Indarrean dagoen ipuina gorde nahi al duzu?"))
			m.show_all()
			if m.run ()==Gtk.ResponseType.YES
				on_guardar_proyecto()
			m.hide()
			
		/*Borrando los archivos temporales???
		for var ar=0 to ultimo_de_lista(archivos_tmp)
			FileUtils.remove(archivos_tmp[ar])
		*/
		
		self.destroy()
		return true
		
	def on_pag_izq (b:Button)
		
		ventana_texto.hide()
		ventana_texto.nuevo_texto.buffer.text=""
		paginas[pagina_activa]=pagina
		if pagina_activa>0
			pagina_activa--
			pagina=new Pagina()
			pagina=paginas[pagina_activa]
			if ultimo_de_lista(pagina.objetos_activos)>=0
				Obj_activo=ultimo_de_lista (pagina.objetos_activos)
			else 
				Obj_activo=-1
			draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
		
		var cad="Katamiro: %s/%s orr"
		title=cad.printf((pagina_activa+1).to_string(),pagina_kopuru.to_string())
		
	
	def on_borrarpag (b:Button) // Eliminar pagina actual.
		guardado=false; 
		if ultimo_de_lista(paginas)>0
			paginas.remove_at (pagina_activa)
			pagina_kopuru--
			if pagina_activa>pagina_kopuru-1 do pagina_activa--
			pagina=paginas[pagina_activa]
			
			var cad="Katamiro: %s/%s orr"
			title=cad.printf((pagina_activa+1).to_string(),pagina_kopuru.to_string())
		
			draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
			Obj_activo=ultimo_de_lista(pagina.objetos_activos)
			tomado=false

		else
			paginas.clear()
			pagina= new Pagina()
			paginas.add(pagina)
			tomado=false
			Obj_tomado=-1
			Obj_activo_escalando=false
			Boca_tomada=-1
			pagina_kopuru= 1
			pagina_activa=0
			Obj_activo=-1
			pagina= paginas[pagina_activa]
			var cad="Katamiro: %s/%s orr"
			title=cad.printf((pagina_activa+1).to_string(),pagina_kopuru.to_string())
			draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
			
	def on_eliminar (b:Button) // Eliminar objeto
		guardado=false; 
		if (Obj_activo!=-1) and (ultimo_de_lista(pagina.objetos_activos)>=0) 
			pagina.objetos_activos.remove_at(Obj_activo)
			draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
			Obj_tomado=-1
			if ultimo_de_lista(pagina.objetos_activos)>=0
				Obj_activo=ultimo_de_lista (pagina.objetos_activos)
			else 
				Obj_activo=-1
			tomado=false

	
	def on_flip1 (b:Button)
		guardado=false; 
		if Obj_activo!=-1 and ultimo_de_lista(pagina.objetos_activos)>=0 and pagina.objetos_activos[Obj_activo].tipo=="Objeto" 
			pagina.objetos_activos[Obj_activo].pixbufer=pagina.objetos_activos[Obj_activo].pixbufer.flip(false)
			draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
			pagina.objetos_activos[Obj_activo].Vflip=not pagina.objetos_activos[Obj_activo].Vflip
		
	def on_flip2 (b:Button)
		guardado=false; 
		if (Obj_activo!=-1) and (ultimo_de_lista(pagina.objetos_activos)>=0) and (pagina.objetos_activos[Obj_activo].tipo=="Objeto") 
			pagina.objetos_activos[Obj_activo].pixbufer=pagina.objetos_activos[Obj_activo].pixbufer.flip(true)
			draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
			pagina.objetos_activos[Obj_activo].Hflip=not pagina.objetos_activos[Obj_activo].Hflip

			
	
	def on_insertar_cuadro()
		guardado=false; 
		Miobjeto= new Objeto()
		Miobjeto.tipo="Cuadro"
		Miobjeto.profundidad=0
		Miobjeto.x=10
		Miobjeto.y=400
		Miobjeto.alto=70
		Miobjeto.ancho=250
		
		pagina.objetos_activos.add (Miobjeto)
		Obj_activo=ultimo_de_lista(pagina.objetos_activos)
		draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
		
	
	
	def on_clic_escenario1 (evento:Gdk.EventButton):bool
		guardado=false; 
		if num_escenario<total_escenarios
			
			case evento.button
				when 1
					pagina.escenario_activo= escenarios[ num_escenario ]
					try
						pagina.escenario_activo.pixbufer= new Gdk.Pixbuf.from_file(DD+"/Escenarios/"+pagina.escenario_activo.archivo)
					except 
						print "error"
					pagina.escenario_es_activo=true
					draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
				when 3
					menuSystem = new Gtk.Menu();
					var menuDelete = new ImageMenuItem.from_stock(Stock.DELETE, null);
					menuDelete.activate.connect(on_borrar_escenario1)
					menuSystem.append(menuDelete);
					menuSystem.show_all();
					menuSystem.popup(null,null,null,0,get_current_event_time () )
				
		return true
		
		
		
		
		
	def on_clic_escenario2 (evento:Gdk.EventButton):bool
		guardado=false; 
		if num_escenario+1<total_escenarios
			case evento.button
				when 1
					pagina.escenario_activo=escenarios[num_escenario+1]
					try
						pagina.escenario_activo.pixbufer= new Gdk.Pixbuf.from_file(DD+"/Escenarios/"+pagina.escenario_activo.archivo)
					except
						print "error"
					pagina.escenario_es_activo=true
					draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
				when 3
					menuSystem = new Gtk.Menu();
					var menuDelete = new ImageMenuItem.from_stock(Stock.DELETE, null);
					menuDelete.activate.connect(on_borrar_escenario2)
					menuSystem.append(menuDelete);
					menuSystem.show_all();
					menuSystem.popup(null,null,null,0,get_current_event_time () )
		return true
		
	def on_clic_escenario3 (evento:Gdk.EventButton):bool
		guardado=false; 
		if num_escenario+2<total_escenarios

			case evento.button
				when 1
					pagina.escenario_activo=escenarios[num_escenario+2]
					try
						pagina.escenario_activo.pixbufer= new Gdk.Pixbuf.from_file(DD+"/Escenarios/"+pagina.escenario_activo.archivo)
					except
						print "error"
					pagina.escenario_es_activo=true
					draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
				when 3
					menuSystem = new Gtk.Menu();
					var menuDelete = new ImageMenuItem.from_stock(Stock.DELETE, null);
					menuDelete.activate.connect(on_borrar_escenario3)
					menuSystem.append(menuDelete);
					menuSystem.show_all();
					menuSystem.popup(null,null,null,0,get_current_event_time () )
		return true
			
	def on_clic_escenario4 (evento:Gdk.EventButton):bool
		guardado=false; 
		if num_escenario+3<total_escenarios

			case evento.button
				when 1
					pagina.escenario_activo=escenarios[num_escenario+3]
					try
						pagina.escenario_activo.pixbufer= new Gdk.Pixbuf.from_file(DD+"/Escenarios/"+pagina.escenario_activo.archivo)
					except
						print "error"
					pagina.escenario_es_activo=true
					draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
				when 3
					menuSystem = new Gtk.Menu();
					var menuDelete = new ImageMenuItem.from_stock(Stock.DELETE, null);
					menuDelete.activate.connect(on_borrar_escenario4)
					menuSystem.append(menuDelete);
					menuSystem.show_all();
					menuSystem.popup(null,null,null,0,get_current_event_time () )
		return true
	
	def borrar_objetox(x:int)
		guardado=false; 
		var i= num_objeto+x
		if i<=total_objetos
			FileUtils.remove(DD+"/Objetos/"+objetos[i].archivo)	
			objetos.clear()
			refresca_objetos(carpeta_objetos_activa)
			refresca_elector_objetos(num_objeto)
	
	def borrar_escenariox(x:int)
		guardado=false; 
		var i= num_escenario+x
		if i<= total_escenarios
			FileUtils.remove(DD+"/Escenarios/"+escenarios[i].archivo)
			escenarios.clear()
			refresca_escenarios(carpeta_escenarios_activa)
			refresca_elector_escenarios(num_escenario)
	
	def on_borrar_escenario1()
		borrar_escenariox(0)
	
	def on_borrar_escenario2()
		borrar_escenariox(1)
	
	def on_borrar_escenario3()
		borrar_escenariox(2)
	
	def on_borrar_escenario4()
		borrar_escenariox(3)
		
		
	
	
	
	def clona (ref dest:Objeto,orig:Objeto)
		dest.x=orig.x
		dest.y=orig.y
		dest.tipo=orig.tipo
		dest.ancho=orig.ancho
		dest.alto=orig.alto
		dest.ancho_original=orig.ancho_original
		dest.alto_original=orig.alto_original
		dest.index=orig.index
		dest.profundidad=orig.profundidad
		dest.nombre=orig.nombre
		dest.archivo=orig.archivo
		dest.icono=orig.icono
		dest.pixbufer=orig.pixbufer
		dest.pixbufer_original=orig.pixbufer_original
		dest.tomado_x=orig.tomado_x
		dest.tomado_y=orig.tomado_y
		dest.Hflip=orig.Hflip
		dest.Vflip=orig.Vflip
		dest.boca_x=orig.boca_x
		dest.boca_y=orig.boca_y
		dest.bocadillo_tipo=orig.bocadillo_tipo
		dest.colorfondo=orig.colorfondo
		dest.colorborde=orig.colorborde
		dest.colorletra=orig.colorletra
	
	
	// Control para la columna de los objetos
	
	def on_clic_objeto1 (evento:Gdk.EventButton):bool
		guardado=false; 
		if num_objeto<total_objetos
			case evento.button
				when 1
					
					Miobjeto= new Objeto
					clona(ref Miobjeto,objetos[num_objeto])
					name=Miobjeto.archivo
					try
						Miobjeto.pixbufer=new Gdk.Pixbuf.from_file(DD+"/Objetos/"+name)
						Miobjeto.pixbufer_original=new Gdk.Pixbuf.from_file(DD+"/Objetos/"+name)
					except
						print "error"
					pagina.objetos_activos.add(Miobjeto)
					Obj_activo=ultimo_de_lista(pagina.objetos_activos)
					draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
				when 3
					menuSystem = new Gtk.Menu();
					var menuConvertir = new ImageMenuItem.from_stock(Stock.CONVERT, null);
					menuConvertir.activate.connect(on_quitar_fondo_1)
					menuSystem.append(menuConvertir);
					var menuDelete = new ImageMenuItem.from_stock(Stock.DELETE, null);
					menuDelete.activate.connect(on_borrar_objeto1)
					menuSystem.append(menuDelete);
					menuSystem.show_all();
					menuSystem.popup(null,null,null,0,get_current_event_time () )
		return true
	
		
	
	def on_clic_objeto2 (evento:Gdk.EventButton):bool
		guardado=false; 
		if num_objeto+1<total_objetos
			case evento.button
				when 1		
					Miobjeto= new Objeto
					clona(ref Miobjeto,objetos[num_objeto+1])
					name=Miobjeto.archivo
					try
						Miobjeto.pixbufer=new Gdk.Pixbuf.from_file(DD+"/Objetos/"+name)
						Miobjeto.pixbufer_original=new Gdk.Pixbuf.from_file(DD+"/Objetos/"+name)
					except
						print "error"
					pagina.objetos_activos.add(Miobjeto)
					Obj_activo=ultimo_de_lista(pagina.objetos_activos)
					draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
				when 3
					menuSystem = new Gtk.Menu();
					var menuConvertir = new ImageMenuItem.from_stock(Stock.CONVERT, null);
					menuConvertir.activate.connect(on_quitar_fondo_2)
					menuSystem.append(menuConvertir);
					var menuDelete = new ImageMenuItem.from_stock(Stock.DELETE, null);
					menuDelete.activate.connect(on_borrar_objeto2)
					menuSystem.append(menuDelete);
					menuSystem.show_all();
					menuSystem.popup(null,null,null,0,get_current_event_time () )
		return true
	
	def on_clic_objeto3 (evento:Gdk.EventButton):bool
		guardado=false; 
		if num_objeto+2<total_objetos
			case evento.button
				when 1		
					Miobjeto= new Objeto
					clona(ref Miobjeto,objetos[num_objeto+2])
					name=Miobjeto.archivo
					try
						Miobjeto.pixbufer=new Gdk.Pixbuf.from_file(DD+"/Objetos/"+name)
						Miobjeto.pixbufer_original=new Gdk.Pixbuf.from_file(DD+"/Objetos/"+name)
					except
						print "error"
					pagina.objetos_activos.add(Miobjeto)
					Obj_activo=ultimo_de_lista(pagina.objetos_activos)
					draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
				when 3
					menuSystem = new Gtk.Menu();
					var menuConvertir = new ImageMenuItem.from_stock(Stock.CONVERT, null);
					menuConvertir.activate.connect(on_quitar_fondo_3)
					menuSystem.append(menuConvertir);
					var menuDelete = new ImageMenuItem.from_stock(Stock.DELETE, null);
					menuDelete.activate.connect(on_borrar_objeto3)
					menuSystem.append(menuDelete);

					menuSystem.show_all();
					menuSystem.popup(null,null,null,0,get_current_event_time () )
		return true
	

	def on_clic_objeto4 (evento:Gdk.EventButton):bool
		guardado=false; 
		if num_objeto+3<total_objetos
			case evento.button
				when 1		
					Miobjeto= new Objeto
					clona(ref Miobjeto,objetos[num_objeto+3])
					name=Miobjeto.archivo
					try
						Miobjeto.pixbufer=new Gdk.Pixbuf.from_file(DD+"/Objetos/"+name)
						Miobjeto.pixbufer_original=new Gdk.Pixbuf.from_file(DD+"/Objetos/"+name)
					except
						print "error"
					pagina.objetos_activos.add(Miobjeto)
					Obj_activo=ultimo_de_lista(pagina.objetos_activos)
					draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
				when 3
					menuSystem = new Gtk.Menu();
					var menuConvertir = new ImageMenuItem.from_stock(Stock.CONVERT, null);
					menuConvertir.activate.connect(on_quitar_fondo_4)
					menuSystem.append(menuConvertir);
					var menuDelete = new ImageMenuItem.from_stock(Stock.DELETE, null);
					menuDelete.activate.connect(on_borrar_objeto4)
					menuSystem.append(menuDelete);
					menuSystem.show_all();
					menuSystem.popup(null,null,null,0,get_current_event_time () )
		return true
	
		
	def on_borrar_objeto1()
		borrar_objetox(0)
		
	def on_borrar_objeto2()
		borrar_objetox(1)
		
	def on_borrar_objeto3()
		borrar_objetox(2)
		
	def on_borrar_objeto4()
		borrar_objetox(3)
		
	def quitar_fondox(e:int)
		guardado=false; 
		//ventana_quitafondo.set_size()
		ventana_quitafondo.inicializa(num_objeto+e)
		ventana_quitafondo.show()
	
	def on_quitar_fondo_1()
		quitar_fondox(0)
				
	def on_quitar_fondo_2()
		quitar_fondox(1)
				
	def on_quitar_fondo_3()
		quitar_fondox(2)
				
	def on_quitar_fondo_4()
		quitar_fondox(3)
		
	def calcula_boca_pentsa(pag:int,i:int ,ro:int,ref r1:int,ref p1_x:int , ref p1_y:int ,ref r2:int, ref p2_x:int , ref p2_y:int,ref r3:int,ref p3_x:int , ref p3_y:int)
		var bx= paginas[pag].objetos_activos[i].boca_x;var by= paginas[pag].objetos_activos[i].boca_y
		var px= paginas[pag].objetos_activos[i].x; var py= paginas[pag].objetos_activos[i].y
		var pw= paginas[pag].objetos_activos[i].ancho; var ph= paginas[pag].objetos_activos[i].alto
		// x=a+my
		
		var ox=px+pw/2; var oy=py+ph/2
		
		var a= -(oy-by)
		var b= ox-bx
		var c= (int)(-by)*b + (-bx)*a  
		p1_x=bx
		p1_y=by		
		if a!=0 and b!=0 and c!=0
			r1=10
			p2_x=(int) bx+(ox-bx)*2/12
			p2_y= (int)(-(a*p2_x)-c)/b
			r2=15 
			p3_x= (int)bx+(ox-bx)*5/12
			p3_y= (int)(-(a*p3_x)-c)/b
			r3=25 
			
	def calcula_boca(pag:int,i:int ,ref p1_y:int , ref p2_y:int , ref p1_x:int , ref p2_x:int)
		var bx= paginas[pag].objetos_activos[i].boca_x;var by= paginas[pag].objetos_activos[i].boca_y
		var px= paginas[pag].objetos_activos[i].x; var py= paginas[pag].objetos_activos[i].y
		var pw= paginas[pag].objetos_activos[i].ancho; var ph= paginas[pag].objetos_activos[i].alto
		
		if (by>py) and (by<(ph)+py)
			if (by<(ph/2)+py)
				p1_y=py+ph*2/7;  p2_y=py+ph*3/7
			else
				p1_y=py+ph*5/7 ; p2_y=py+ph*6/7
			if (bx<px)
				p1_x=px; p2_x=px;
			else
				p1_x=px+pw; p2_x=px+pw
			
		else
		
			if (bx<(pw/2)+px)
				p1_x=px+pw*2/7;  p2_x=px+pw*3/7
			else
				p1_x=px+pw*5/7 ; p2_x=px+pw*6/7
			if (by<py)
				p1_y=py; p2_y=py;
			else
				p1_y=py+ph; p2_y=py+ph

		
	/////////////////////////////////////////////////// control de los eventos de la pantalla ///////////////////
	def on_deja (evento:Gdk.EventButton):bool
		guardado=false; 
		tomado=false
		Obj_tomado=-1
		Obj_activo_escalando=false
		Boca_tomada=-1
		draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
		return true

	def on_toma (evento:Gdk.EventButton):bool
		guardado=false; 

		var x=(int)evento.x
		var y=(int)evento.y
			
		if (Obj_activo!=-1) // objeturik badago eskenatokian
			var py=pagina.objetos_activos[Obj_activo].y 
			var px=pagina.objetos_activos[Obj_activo].x
			var pw=pagina.objetos_activos[Obj_activo].x +pagina.objetos_activos[Obj_activo].ancho
			var ph=pagina.objetos_activos[Obj_activo].y +pagina.objetos_activos[Obj_activo].alto 
			Obj_activo_escalando=false
			
			if (x<pw) and (pw-20<x) and (ph>y) and (ph-20<y)
				Obj_activo_escalando=true
			else
				Boca_tomada=-1 // Mira si se ha tomado la boca para moverla
				if (Obj_activo!=-1) and ((pagina.objetos_activos[Obj_activo].tipo=="Borobilhitz") or (pagina.objetos_activos[Obj_activo].tipo=="Bocadillo") or (pagina.objetos_activos[Obj_activo].tipo=="Borobilpentsa")) and (pagina.objetos_activos[Obj_activo].boca_x-5<x) and (pagina.objetos_activos[Obj_activo].boca_x+5>x) and (pagina.objetos_activos[Obj_activo].boca_y-5<y) and (pagina.objetos_activos[Obj_activo].boca_y+5>y)
					Boca_tomada=Obj_activo
					 
				else 
					if  (x<pw) and (pw-20<x) and (py<y) and (py+20>y) and (pagina.objetos_activos[Obj_activo].tipo!="Objeto")
						ventana_texto.define_valores(Obj_activo,pagina.objetos_activos[Obj_activo].x,pagina.objetos_activos[Obj_activo].y,pagina.objetos_activos[Obj_activo].ancho,pagina.objetos_activos[Obj_activo].alto)
						ventana_texto.hide()
						var thisx=0; var thisy=0
						this.get_position(out thisx,out thisy)
						ventana_texto.move(px+thisx,py+thisy)
						ventana_texto.show()
						ventana_texto.set_focus(ventana_texto.nuevo_texto)
					else
						for var n= 0 to ultimo_de_lista(pagina.objetos_activos)
							var i=ultimo_de_lista(pagina.objetos_activos)-n
							if (pagina.objetos_activos[i].x<x) and (pagina.objetos_activos[i].x+pagina.objetos_activos[i].ancho>x) and (pagina.objetos_activos[i].y<y) and (pagina.objetos_activos[i].y+pagina.objetos_activos[i].alto>y)
								if Obj_tomado!=i 
									tomado=true
									Obj_activo=i
									// tomamos los datos de posición para dejarlos en tomado_x y tomado_y
									pagina.objetos_activos[i].tomado_x= x- pagina.objetos_activos[i].x
									pagina.objetos_activos[i].tomado_y= y- pagina.objetos_activos[i].y
									Obj_tomado=i
									
									// movemos el objeto al último puesto de la lista de los objetos activos para que aparezca sobre todos.
									Miobjeto=new Objeto
									Miobjeto = pagina.objetos_activos[Obj_activo]
									pagina.objetos_activos.remove_at(Obj_activo)
									pagina.objetos_activos.add(Miobjeto)
									Obj_activo=ultimo_de_lista(pagina.objetos_activos)
									Obj_tomado=Obj_activo
									
									draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto) //Refresca la pantalla
									break
		return true

	def on_mover(evento:Gdk.EventMotion):bool
		var x=(int)evento.x
		var y=(int)evento.y
		// procuraremos que los objetos se mantengan dentro de los límites, para que así no queden escondidos en 
		// coordenadas externas a nuestras posibilidades de acción con el puntero del ratón en la pizarra.
		if x<12 do x=15
		if x>Lienzo_ancho-12 do x= Lienzo_ancho-15
		if y<12 do y=15
		if y>Lienzo_alto-12 do  y= Lienzo_alto-15
			
			
			
		if tomado  // si objeto esta en posesión de usuario
			if Obj_tomado>=0 //moviendo el objeto normalmente un objeto de la lista de objetos. Verificación cual es.
				guardado=false;
				pagina.objetos_activos[Obj_tomado].x=x-(int)pagina.objetos_activos[Obj_tomado].tomado_x
				pagina.objetos_activos[Obj_tomado].y=y-(int)pagina.objetos_activos[Obj_tomado].tomado_y
			
				draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto) //Refresca la pantalla
		
		if Obj_activo_escalando // escalando el objeto puesto que cuando escalamos estamos haciendo un movimiento.
			guardado=false;
			var tope=30// el minimo escalable es 30 pero según el tamaño de letra se modifica
			if pagina.objetos_activos[Obj_activo].tipo =="Bocadillo" do tope=60+(int)pagina.objetos_activos[Obj_activo].tamano_texto 
			
			if x>pagina.objetos_activos[Obj_activo].x+tope and y>pagina.objetos_activos[Obj_activo].y+30 // escalando la imagen o bocadillo
				// guardamos en estas variables los anchos y altos nuevos
				var ancho=x-pagina.objetos_activos[Obj_activo].x
				var alto=y-pagina.objetos_activos[Obj_activo].y
				// redimensiona en el caso de que sea un objeto(imagen).
				if pagina.objetos_activos[Obj_activo].tipo=="Objeto" do pagina.objetos_activos[Obj_activo].pixbufer = pagina.objetos_activos[Obj_activo].pixbufer_original.scale_simple(ancho,alto, Gdk.InterpType.NEAREST)
				// deja los datos de la redimensión
				pagina.objetos_activos[Obj_activo].ancho=ancho
				pagina.objetos_activos[Obj_activo].alto=alto
				//recoloca en caso de flip
				if pagina.objetos_activos[Obj_activo].Hflip do pagina.objetos_activos[Obj_activo].pixbufer=pagina.objetos_activos[Obj_activo].pixbufer.flip(true)
				if pagina.objetos_activos[Obj_activo].Vflip do pagina.objetos_activos[Obj_activo].pixbufer=pagina.objetos_activos[Obj_activo].pixbufer.flip(false)
				
				//redimensiona el texto
				ventana_texto.define_valores(Obj_activo,pagina.objetos_activos[Obj_activo].x,pagina.objetos_activos[Obj_activo].y,pagina.objetos_activos[Obj_activo].ancho,pagina.objetos_activos[Obj_activo].alto)
				draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto) //Refresca la pantalla
				
			
		if Boca_tomada!=-1 // movimiento de la boca
			guardado=false;
			pagina.objetos_activos[Boca_tomada].boca_x=x
			pagina.objetos_activos[Boca_tomada].boca_y=y
			draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto) //Refresca la pantalla

		return true
	

	def on_expose(e : Gtk.Widget,cr:Context) : bool
		//cr = Gdk.cairo_create(e.window) //deprecated
		
		if pagina.escenario_es_activo
			Gdk.cairo_set_source_pixbuf(cr, pagina.escenario_activo.pixbufer, 0, 0) //pinta el escenario
			cr.paint ()
			
		else // si no existe el escenario escribiremos que no existe escenario
			cr.set_source_rgb(0, 0, 0)
			cr.select_font_face("KatamotzIkasi", Cairo.FontSlant.NORMAL, Cairo.FontWeight.NORMAL)
			cr.set_font_size(20)
			cr.move_to(200, 230)
			
			var cad=t.t("Eskenatorikik gabe. Orrialdea: %s/%s ")
			cr.show_text ( cad.printf( (pagina_activa+1).to_string(),pagina_kopuru.to_string()))
			cr.stroke()

		for var i=0 to (ultimo_de_lista(pagina.objetos_activos))
			if pagina.objetos_activos[i].tipo == "Objeto"
				Gdk.cairo_set_source_pixbuf(cr, pagina.objetos_activos[i].pixbufer , pagina.objetos_activos[i].x, pagina.objetos_activos[i].y)
				cr.paint ()
			
			if pagina.objetos_activos[i].tipo == "Bocadillo"
				// haz el recuadro normal
				cr.set_source_rgb(1, 1, 1)
				cr.set_line_width(2)
				cr.rectangle(pagina.objetos_activos[i].x,pagina.objetos_activos[i].y,pagina.objetos_activos[i].ancho,pagina.objetos_activos[i].alto)
				cr.fill()
				if i==Obj_activo // si está activo pondremos en la boca un cuadro señal.
					
					cr.set_source_rgb(0, 0, 0)
					cr.set_line_width(2)
					cr.rectangle(pagina.objetos_activos[i].boca_x-5,pagina.objetos_activos[i].boca_y-5,10,10)
					cr.fill()
				// Creación del triangulo de la boca del bocadillo
				// llamando a una funcion para despejar la funcion de tanto calculo
				
				var p1_y=0 ; var p2_y=0; var p1_x=0; var p2_x=0
				calcula_boca(pagina_activa,i,ref p1_y , ref p2_y , ref p1_x , ref p2_x)
				var bx= pagina.objetos_activos[i].boca_x;var by= pagina.objetos_activos[i].boca_y
				var px= pagina.objetos_activos[i].x; var py= pagina.objetos_activos[i].y
				cr.move_to (p1_x ,p1_y ) ;  cr.line_to (bx,by); cr.line_to (p2_x,p2_y); cr.line_to (p2_x,p2_y)
				cr.close_path();
				cr.set_source_rgb( 1, 1, 1);
				cr.stroke_preserve();
				cr.set_source_rgb( 1, 1, 1);
				cr.fill()
				
				
				//recuadra todo el bocadillo incluyendo la boca
				cr.set_source_rgb(0, 0, 0)
				cr.set_line_width(2)
				cr.rectangle(pagina.objetos_activos[i].x,pagina.objetos_activos[i].y,pagina.objetos_activos[i].ancho,pagina.objetos_activos[i].alto)
				cr.stroke()
				
				cr.set_source_rgb(1, 1, 1)
				cr.set_line_width(2)
				cr.move_to (p1_x ,p1_y );cr.line_to (p2_x,p2_y)
				cr.stroke()
				
				cr.set_source_rgb(0, 0, 0)
				cr.set_line_width(2)
				cr.move_to (p1_x ,p1_y ) ;  cr.line_to (bx,by); cr.line_to (p2_x,p2_y);
				cr.stroke()
				
				//escribe dentro del bocadillo
				cr.set_source_rgb(0, 0, 0)
				cr.select_font_face("KatamotzIkasi", Cairo.FontSlant.NORMAL, Cairo.FontWeight.NORMAL)
				cr.set_font_size(pagina.objetos_activos[i].tamano_texto)
				px= pagina.objetos_activos[i].x; py= pagina.objetos_activos[i].y
				if ultimo_de_lista(pagina.objetos_activos[i].texto)>=0
					for var n=0 to ultimo_de_lista(pagina.objetos_activos[i].texto)
						cr.move_to(px+5, py+pagina.objetos_activos[i].tamano_texto+n*pagina.objetos_activos[i].tamano_texto)
						cr.show_text (pagina.objetos_activos[i].texto[n])
						cr.stroke()
						
			if pagina.objetos_activos[i].tipo == "Borobilhitz"
					
				if i==Obj_activo // si está activo pondremos en la boca un cuadro señal.	
					cr.set_source_rgb(0, 0, 0)
					cr.set_line_width(2)
					cr.rectangle(pagina.objetos_activos[i].boca_x-5,pagina.objetos_activos[i].boca_y-5,10,10)
					cr.fill()
				
				
				// rellena una elipse 		
				cr.save()
				cr.set_source_rgb( 1, 1, 1);
				cr.translate(pagina.objetos_activos[i].x+  pagina.objetos_activos[i].ancho/2,
				pagina.objetos_activos[i].y+  pagina.objetos_activos[i].alto/2)
				var radio=0.0
				if pagina.objetos_activos[i].alto>pagina.objetos_activos[i].ancho
					cr.scale(0.1+(double)1/(pagina.objetos_activos[i].alto/pagina.objetos_activos[i].ancho),1);
					radio=pow( pow(pagina.objetos_activos[i].ancho/2,2)+pow(pagina.objetos_activos[i].alto/2,2),0.52)
				
				else
					cr.scale(1,0.1+(double)1/(pagina.objetos_activos[i].ancho/pagina.objetos_activos[i].alto));
					radio=pow(pow(pagina.objetos_activos[i].ancho/2,2)+pow(pagina.objetos_activos[i].alto/2,2),0.52)
							
				cr.arc(0,0,radio, 0.0, 2 * 3.14);
				cr.fill()
				cr.restore()
				
				// crea el borde  una elipse 		
				cr.save()
				cr.set_source_rgb( 0, 0, 0);
				cr.translate(pagina.objetos_activos[i].x+  pagina.objetos_activos[i].ancho/2,
				pagina.objetos_activos[i].y+  pagina.objetos_activos[i].alto/2)
				radio=0.0
				if pagina.objetos_activos[i].alto>pagina.objetos_activos[i].ancho
					cr.scale(0.1+(double)1/(pagina.objetos_activos[i].alto/pagina.objetos_activos[i].ancho),1);
					radio=pow( pow(pagina.objetos_activos[i].ancho/2,2)+pow(pagina.objetos_activos[i].alto/2,2),0.52)
				
				else
					cr.scale(1,0.1+(double)1/(pagina.objetos_activos[i].ancho/pagina.objetos_activos[i].alto));
					radio=pow(pow(pagina.objetos_activos[i].ancho/2,2)+pow(pagina.objetos_activos[i].alto/2,2),0.52)				
				cr.arc(0,0,radio, 0.0, 2 * 3.14);
				cr.stroke()
				cr.restore()
				
				
				
				// Creación del triangulo de la boca del bocadillo
				// llamando a una funcion para despejar la funcion de tanto calculo
				
				
				var p1_y=0 ; var p2_y=0; var p1_x=0; var p2_x=0
				calcula_boca(pagina_activa,i,ref p1_y , ref p2_y , ref p1_x , ref p2_x)
				var bx= pagina.objetos_activos[i].boca_x;var by= pagina.objetos_activos[i].boca_y
				var px= pagina.objetos_activos[i].x; var py= pagina.objetos_activos[i].y
				cr.move_to (p1_x ,p1_y ) ; cr.line_to (bx,by); cr.line_to (p2_x,p2_y); cr.line_to (p1_x,p1_y)
				cr.close_path();
				cr.set_source_rgb( 1, 1, 1);
				cr.stroke_preserve();
				cr.set_source_rgb( 1, 1, 1);
				cr.fill()
				
				cr.set_source_rgb(1, 1, 1)
				cr.set_line_width(2)
				cr.move_to (p1_x ,p1_y );cr.line_to (p2_x,p2_y)
				cr.stroke()
				
				cr.set_source_rgb(0, 0, 0)
				cr.set_line_width(2)
				cr.move_to (p1_x ,p1_y ) ;  cr.line_to (bx,by); cr.line_to (p2_x,p2_y);
				cr.stroke()
				
				
				//escribe dentro del bocadillo
				cr.set_source_rgb(0, 0, 0)
				cr.select_font_face("KatamotzIkasi", Cairo.FontSlant.NORMAL, Cairo.FontWeight.NORMAL)
				cr.set_font_size(pagina.objetos_activos[i].tamano_texto)
				px= pagina.objetos_activos[i].x; py= pagina.objetos_activos[i].y
				if ultimo_de_lista(pagina.objetos_activos[i].texto)>=0
					for var n=0 to ultimo_de_lista(pagina.objetos_activos[i].texto)
						cr.move_to(px+5, py+pagina.objetos_activos[i].tamano_texto+n*pagina.objetos_activos[i].tamano_texto)
						cr.show_text (pagina.objetos_activos[i].texto[n])
						cr.stroke()
						
			if pagina.objetos_activos[i].tipo=="Borobilpentsa"
				if i==Obj_activo // si está activo pondremos en la boca un cuadro señal.	
					cr.set_source_rgb(0, 0, 0)
					cr.set_line_width(2)
					cr.rectangle(pagina.objetos_activos[i].boca_x-5,pagina.objetos_activos[i].boca_y-5,10,10)
					cr.fill()
					
				
				//var bx= pagina.objetos_activos[i].boca_x;	var by= pagina.objetos_activos[i].boca_y
				var px= pagina.objetos_activos[i].x;		var py= pagina.objetos_activos[i].y
				// llamando a una funcion para despejar la funcion de tanto calculo
				var p1_x=0 ; var p1_y=0; var p2_x=0; var p2_y=0; var p3_x=0; var p3_y=0
				var r1=0; var r2=0; var r3=0;
				calcula_boca_pentsa(pagina_activa,i,10,ref r1,ref p1_x , ref p1_y ,ref r2, ref p2_x , ref p2_y,ref r3,ref p3_x , ref p3_y)
				
				
				cr.set_source_rgb( 0, 0, 0);	
				cr.arc(p1_x ,p1_y ,10, 0.0, 2 * 3.14);
				cr.stroke()
				
				cr.set_source_rgb( 1, 1, 1);
				cr.arc(p1_x ,p1_y ,r1, 0.0, 2 * 3.14);
				cr.fill()
				
				cr.set_source_rgb( 0, 0, 0);
				cr.arc(p1_x ,p1_y ,r1, 0.0, 2 * 3.14);
				cr.stroke()
				
				cr.set_source_rgb( 1, 1, 1);
				cr.arc(p2_x ,p2_y ,r2, 0.0, 2 * 3.14);
				cr.fill()
				
				cr.set_source_rgb( 0, 0, 0);
				cr.arc(p2_x ,p2_y ,r2, 0.0, 2 * 3.14);
				cr.stroke()
				
				cr.set_source_rgb( 1, 1, 1);
				cr.arc(p3_x ,p3_y ,r3, 0.0, 2 * 3.14);
				cr.fill()
				
				cr.set_source_rgb( 0, 0, 0);
				cr.arc(p3_x ,p3_y ,r3, 0.0, 2 * 3.14);
				cr.stroke()
				
				
				
				// rellena una elipse 		
				cr.save()
				cr.set_source_rgb( 1, 1, 1);
				cr.translate(pagina.objetos_activos[i].x+  pagina.objetos_activos[i].ancho/2,
				pagina.objetos_activos[i].y+  pagina.objetos_activos[i].alto/2)
				var radio=0.0
				if pagina.objetos_activos[i].alto>pagina.objetos_activos[i].ancho
					cr.scale(0.1+(double)1/(pagina.objetos_activos[i].alto/pagina.objetos_activos[i].ancho),1);
					radio=pow( pow(pagina.objetos_activos[i].ancho/2,2)+pow(pagina.objetos_activos[i].alto/2,2),0.52)
				
				else
					cr.scale(1,0.1+(double)1/(pagina.objetos_activos[i].ancho/pagina.objetos_activos[i].alto));
					radio=pow(pow(pagina.objetos_activos[i].ancho/2,2)+pow(pagina.objetos_activos[i].alto/2,2),0.52)
							
				cr.arc(0,0,radio, 0.0, 2 * 3.14);
				cr.fill()
				cr.restore()
				
				
				// crea el borde  una elipse 		
				cr.save()
				cr.set_source_rgb( 0, 0, 0);
				cr.translate(pagina.objetos_activos[i].x+  pagina.objetos_activos[i].ancho/2,
				pagina.objetos_activos[i].y+  pagina.objetos_activos[i].alto/2)
				radio=0.0
				if pagina.objetos_activos[i].alto>pagina.objetos_activos[i].ancho
					cr.scale(0.1+(double)1/(pagina.objetos_activos[i].alto/pagina.objetos_activos[i].ancho),1);
					radio=pow( pow(pagina.objetos_activos[i].ancho/2,2)+pow(pagina.objetos_activos[i].alto/2,2),0.52)
				
				else
					cr.scale(1,0.1+(double)1/(pagina.objetos_activos[i].ancho/pagina.objetos_activos[i].alto));
					radio=pow(pow(pagina.objetos_activos[i].ancho/2,2)+pow(pagina.objetos_activos[i].alto/2,2),0.52)				
				cr.arc(0,0,radio, 0.0, 2 * 3.14);
				cr.stroke()
				cr.restore()
				
				
				
				if i==Obj_activo // si está activo pondremos en la boca un cuadro señal.	
					cr.set_source_rgb(0, 0, 0)
					cr.set_line_width(2)
					cr.rectangle(pagina.objetos_activos[i].boca_x-5,pagina.objetos_activos[i].boca_y-5,10,10)
					cr.fill()
				
				
				
				//escribe dentro del bocadillo
				cr.set_source_rgb(0, 0, 0)
				cr.select_font_face("KatamotzIkasi", Cairo.FontSlant.NORMAL, Cairo.FontWeight.NORMAL)
				cr.set_font_size(pagina.objetos_activos[i].tamano_texto)
				px= pagina.objetos_activos[i].x; py= pagina.objetos_activos[i].y
				
				if ultimo_de_lista(pagina.objetos_activos[i].texto)>=0
					for var n=0 to ultimo_de_lista(pagina.objetos_activos[i].texto)
						cr.move_to(px+5, py+pagina.objetos_activos[i].tamano_texto+n*pagina.objetos_activos[i].tamano_texto)
						cr.show_text (pagina.objetos_activos[i].texto[n])
						cr.stroke()

			if pagina.objetos_activos[i].tipo=="Cuadro"
				// haz el recuadro normal
				cr.set_source_rgb(1, 1, 1)
				cr.set_line_width(2)
				cr.rectangle(pagina.objetos_activos[i].x,pagina.objetos_activos[i].y,pagina.objetos_activos[i].ancho,pagina.objetos_activos[i].alto)
				cr.fill()
				
				//escribe dentro del bocadillo
				cr.set_source_rgb(0, 0, 0)
				cr.select_font_face("KatamotzIkasi", Cairo.FontSlant.NORMAL, Cairo.FontWeight.NORMAL)
				cr.set_font_size(pagina.objetos_activos[i].tamano_texto)
				
				var px= pagina.objetos_activos[i].x; var py= pagina.objetos_activos[i].y
				if ultimo_de_lista(pagina.objetos_activos[i].texto)>=0
					for var n=0 to ultimo_de_lista(pagina.objetos_activos[i].texto)
						cr.move_to(px+5, py+pagina.objetos_activos[i].tamano_texto+n*pagina.objetos_activos[i].tamano_texto)
						cr.show_text (pagina.objetos_activos[i].texto[n])
						cr.stroke()
		// dibujar el recuadro que marca el objeto activo y los controles del objeto activo: escalar, rotar etc.
		if Obj_activo>=0
			cr.set_source_rgb(0, 0, 0)
			cr.set_line_width(1)
			cr.rectangle(pagina.objetos_activos[Obj_activo].x,pagina.objetos_activos[Obj_activo].y,pagina.objetos_activos[Obj_activo].ancho,pagina.objetos_activos[Obj_activo].alto)
			cr.stroke()
			// escribe el dibujo de escalado dentro del recuadro de objeto activo
			cr.set_source_surface(Srf_escalar,pagina.objetos_activos[Obj_activo].x+pagina.objetos_activos[Obj_activo].ancho-20,pagina.objetos_activos[Obj_activo].y+pagina.objetos_activos[Obj_activo].alto-20)
			cr.paint()
			
			// escribe el dibujo de texto  dentro del recuadro de objeto activo
			case pagina.objetos_activos[Obj_activo].tipo
				when "Bocadillo","Cuadro","Borobilhitz","Borobilpentsa"
					cr.set_source_surface(Srf_texto,pagina.objetos_activos[Obj_activo].x+pagina.objetos_activos[Obj_activo].ancho-20,pagina.objetos_activos[Obj_activo].y)
					cr.paint()
		
		
		return true
		
	def on_guardar_proyecto ()
		if not guardado
			var FC=  new FileChooserDialog (t.t("Aukeratu karpeta bat proiektua gordetzeko"), this, Gtk.FileChooserAction.SELECT_FOLDER,
					Gtk.Stock.CANCEL,
					Gtk.ResponseType.CANCEL,
					Gtk.Stock.SAVE,
					Gtk.ResponseType.ACCEPT);
			
			FC.set_current_folder (UD)
			FC.select_multiple = false;
			FC.set_modal(true)
			case FC.run ()
				when Gtk.ResponseType.CANCEL 
					FC.close()
					FC.hide()

				when Gtk.ResponseType.ACCEPT
					
					var error=false
					//Estructura del archivo "ipuina": *** para nombre de escenario, --- Para objetos,  ___ para texto
					var directorio=FC.get_filename ();
					UD=directorio
					FC.close()
					FC.hide()
					try
						var dir = File.new_for_commandline_arg (directorio)
						dir.make_directory ()
					except
						pass
					try
						// borrar todos los archivos del directorio
						var d = Dir.open( directorio )
						while ((name = d.read_name()) != null) 
							if name[0:4]=="ktm_"
								FileUtils.remove(directorio+"/"+name)
					except
						print "no se pudo borrar"
					
					try
						// abrir el archivo
						file = File.new_for_path (directorio+"/ktm_ipuina")
						os = file.create (FileCreateFlags.PRIVATE)
					except
						print "error creando arhcivo"
						error=true
					if not error
						for var pag=0 to ultimo_de_lista(paginas)
							try
								os.write("***".data)
									
								if paginas[pag].escenario_es_activo
									os.write((paginas[pag].escenario_activo.archivo+"\n").data) 									
									paginas[pag].escenario_activo.pixbufer.save(directorio+"/ktm_"+paginas[pag].escenario_activo.archivo,"png")
									
									
									
									
								else
									os.write("???\n".data)
							except
								print "error en grabar escenarios"
								
							var datos= ""
							var datos2= ""
							
							for var o=0 to ultimo_de_lista(paginas[pag].objetos_activos)
								try
									if paginas[pag].objetos_activos[o].tipo=="Bocadillo"
										datos="---Bocadillo,"
									if paginas[pag].objetos_activos[o].tipo=="Cuadro"
										datos="---Cuadro,"
									if paginas[pag].objetos_activos[o].tipo=="Borobilhitz"
										datos="---Borobilhitzpi,"
									if paginas[pag].objetos_activos[o].tipo=="Borobilpentsa"
										datos="---Borobilpentsa,"
									
									if paginas[pag].objetos_activos[o].tipo=="Objeto"
										datos= ("---"+paginas[pag].objetos_activos[o].archivo+",")
										
										paginas[pag].objetos_activos[o].pixbufer_original.save(directorio+"/ktm_"+paginas[pag].objetos_activos[o].archivo,"png")
										
									datos+=paginas[pag].objetos_activos[o].tipo+","
									datos+=paginas[pag].objetos_activos[o].x.to_string()+","
									datos+=paginas[pag].objetos_activos[o].y.to_string()+","
									datos+=paginas[pag].objetos_activos[o].ancho.to_string()+","
									datos+=paginas[pag].objetos_activos[o].alto.to_string()+","
									datos+=paginas[pag].objetos_activos[o].Hflip.to_string()+","
									datos+=paginas[pag].objetos_activos[o].Vflip.to_string()+","
									datos+=paginas[pag].objetos_activos[o].boca_x.to_string()+","
									datos+=paginas[pag].objetos_activos[o].boca_y.to_string()+","
									datos+=paginas[pag].objetos_activos[o].bocadillo_tipo.to_string()+","
									datos+=paginas[pag].objetos_activos[o].tamano_texto.to_string()+"\n"
									
									datos2=""
									for var s=0 to ultimo_de_lista(paginas[pag].objetos_activos[o].texto_original)
										datos2+="___"+paginas[pag].objetos_activos[o].texto_original[s].to_string()+"\n"
									
									os.write (datos.data)
									case paginas[pag].objetos_activos[o].tipo
										when "Bocadillo" ,"Cuadro","Borobilhitz","Borobilpentsa"
											os.write (datos2.data)
								except
									print "error grabando objetos"
									
					guardado=true
					
					


	
	
	
	def on_abrir_proyecto ()
	
		var FC=  new FileChooserDialog (t.t("Aukeratu karpeta bat proiektua aukeratzeko"), this, Gtk.FileChooserAction.SELECT_FOLDER,
				Gtk.Stock.CANCEL,
				Gtk.ResponseType.CANCEL,
				Gtk.Stock.OPEN,
				Gtk.ResponseType.ACCEPT);
		
		FC.set_current_folder (UD)
		FC.select_multiple = false;
		case FC.run ()
			when Gtk.ResponseType.CANCEL 
				FC.close()
		
			when Gtk.ResponseType.ACCEPT
				//Estructura del archivo "ipuina": *** para nombre de escenario, --- Para objetos,  ___ para texto
				var directorio=FC.get_filename ()
				UD= directorio
				FC.close()
				var lista =new list of string
				f:FileStream
				f = FileStream.open(directorio+"/ktm_ipuina","r")
				if f==null
					var m= new MessageDialog(this,DialogFlags.MODAL,MessageType.WARNING,ButtonsType.OK,t.t("No se ha encontrado archivo"))
					m.show_all()
					if m.run ()==Gtk.ResponseType.OK do m.hide()

				else
					var a = new array of char[1000]
					var bu = new StringBuilder ()
					while f.gets(a)!= null
						for s in a do bu.append_c(s)
							lista.add (bu.str)
							bu.erase()
					paginas.clear()
					pagina_activa=-1
					var ancho=0
					var alto=0
					var linea=""
					var n=0
					while n<=ultimo_de_lista(lista)
						linea= lista[n]
						n++
						if linea[0:3]=="***"
							var P= new Pagina()
							var E= new Objeto()
							if linea[3:-1]!="???"
								try
									
									E.pixbufer=new Gdk.Pixbuf.from_file(directorio+"/ktm_"+linea[3:-1])
									
									P.escenario_es_activo=true
									P.escenario_activo=E
									P.escenario_activo.archivo=linea[3:-1]
									
							
								except
									print "error tomando escenario"
							else
								P.escenario_es_activo=false
								P.escenario_activo=E
							
							paginas.add(P)
							pagina_activa++
							pagina=paginas[pagina_activa]
							Obj_activo=-1
							
						if linea[0:3]=="---"
							Obj_activo++
							var txt=linea[3:-1]
							var partes= txt.split (",",500)
							
							var O= new Objeto
							paginas[pagina_activa].objetos_activos.add(O)
							
							
							paginas[pagina_activa].objetos_activos[Obj_activo].tipo=partes[1]
							paginas[pagina_activa].objetos_activos[Obj_activo].x= int.parse(partes[2])
							paginas[pagina_activa].objetos_activos[Obj_activo].y=int.parse(partes[3])
							paginas[pagina_activa].objetos_activos[Obj_activo].ancho=int.parse(partes[4])
							paginas[pagina_activa].objetos_activos[Obj_activo].alto=int.parse(partes[5])
							
							paginas[pagina_activa].objetos_activos[Obj_activo].Hflip=bool.parse(partes[6])
							paginas[pagina_activa].objetos_activos[Obj_activo].Vflip==bool.parse(partes[7])
							
							paginas[pagina_activa].objetos_activos[Obj_activo].boca_x=int.parse(partes[8])
							paginas[pagina_activa].objetos_activos[Obj_activo].boca_y=int.parse(partes[9])
							
							paginas[pagina_activa].objetos_activos[Obj_activo].bocadillo_tipo=int.parse(partes[10])
							
							paginas[pagina_activa].objetos_activos[Obj_activo].tamano_texto=int.parse(partes[11])
							
							
							if paginas[pagina_activa].objetos_activos[Obj_activo].tipo=="Objeto"
								paginas[pagina_activa].objetos_activos[Obj_activo].archivo=partes[0]
								
								try
									paginas[pagina_activa].objetos_activos[Obj_activo].pixbufer_original=new Gdk.Pixbuf.from_file (directorio+"/ktm_"+partes[0] )
									ancho= paginas[pagina_activa].objetos_activos[Obj_activo].ancho
									alto =paginas[pagina_activa].objetos_activos[Obj_activo].alto
									paginas[pagina_activa].objetos_activos[Obj_activo].pixbufer = paginas[pagina_activa].objetos_activos[Obj_activo].pixbufer_original.scale_simple(ancho,alto, Gdk.InterpType.NEAREST)
									//recoloca en caso de flip
									if paginas[pagina_activa].objetos_activos[Obj_activo].Hflip do paginas[pagina_activa].objetos_activos[Obj_activo].pixbufer=paginas[pagina_activa].objetos_activos[Obj_activo].pixbufer.flip(true)
									if paginas[pagina_activa].objetos_activos[Obj_activo].Vflip do paginas[pagina_activa].objetos_activos[Obj_activo].pixbufer=paginas[pagina_activa].objetos_activos[Obj_activo].pixbufer.flip(false)
							
								except
									print "errores en objeto"
						if linea[0:3]=="___"
							paginas[pagina_activa].objetos_activos[Obj_activo].texto_original.add(linea[3:-1])
							ventana_texto.define_valores(Obj_activo,pagina.objetos_activos[Obj_activo].x,pagina.objetos_activos[Obj_activo].y,pagina.objetos_activos[Obj_activo].ancho,pagina.objetos_activos[Obj_activo].alto)
							ventana_texto.on_introduce()
				
			
			
			tomado=false
			Obj_tomado=-1
			Obj_activo_escalando=false
			
			Boca_tomada=-1
			pagina_kopuru= tamano_de_lista(paginas)
			
			pagina_activa=0
			pagina= paginas[pagina_activa]
			Obj_activo=ultimo_de_lista(pagina.objetos_activos)
			guardado=true
			
			var cad= t.t("Katamiro: %s/%s orr")
			title= cad.printf( (pagina_activa+1).to_string(),pagina_kopuru.to_string())
			draw_area.queue_draw_area(0,0,Lienzo_ancho,Lienzo_alto)
			




	
	def on_exposepdf_2()
		if not guardado
			var m= new MessageDialog(this,DialogFlags.MODAL,MessageType.WARNING,ButtonsType.OK,t.t("Sentitzen dut, baina proiektua gorde lehenegoz"))
			m.show_all()
			if m.run ()==Gtk.ResponseType.OK do m.hide()

		else
			var cad=t.t("%s direktorioan gordeko da")
			var m= new MessageDialog(this,DialogFlags.MODAL,MessageType.WARNING,ButtonsType.OK_CANCEL,cad.printf(UD))
			m.show_all()
			case m.run()
				when Gtk.ResponseType.CANCEL 
					m.hide()
				when Gtk.ResponseType.OK			
					m.hide()
					try
						var dir = File.new_for_commandline_arg (UD+"/png-pdf")
						dir.make_directory ()
					except
						pass
					
					ventana_conversion_pdf.inicializa(pagina_kopuru)
	
	
	
	def crear_contexto(ct:Context,pag:int)
		
		if paginas[pag].escenario_es_activo
			Gdk.cairo_set_source_pixbuf(ct, paginas[pag].escenario_activo.pixbufer, 0, 0) //pinta el escenario
			ct.paint ()
			
		// vamos a por los objetos
		for var i=0 to (ultimo_de_lista(paginas[pag].objetos_activos))
			if paginas[pag].objetos_activos[i].tipo=="Objeto"
				Gdk.cairo_set_source_pixbuf(ct, paginas[pag].objetos_activos[i].pixbufer , paginas[pag].objetos_activos[i].x, paginas[pag].objetos_activos[i].y)
				ct.paint ()
				
			if paginas[pag].objetos_activos[i].tipo=="Bocadillo"
				// haz el recuadro normal
				ct.set_source_rgb(1, 1, 1)
				ct.set_line_width(2)
				ct.rectangle(paginas[pag].objetos_activos[i].x,paginas[pag].objetos_activos[i].y,paginas[pag].objetos_activos[i].ancho,paginas[pag].objetos_activos[i].alto)
				ct.fill()
				// Creación del triangulo de la boca del bocadillo
				// llamada a una funcion para despejar la funcion de tanto calculo
				
				var p1_y=0 ; var p2_y=0; var p1_x=0; var p2_x=0
				calcula_boca(pag,i,ref p1_y , ref p2_y , ref p1_x , ref p2_x)
				var bx= paginas[pag].objetos_activos[i].boca_x;var by= paginas[pag].objetos_activos[i].boca_y
				var px= paginas[pag].objetos_activos[i].x; var py= paginas[pag].objetos_activos[i].y
				ct.move_to (p1_x ,p1_y ) ;  ct.line_to (bx,by); ct.line_to (p2_x,p2_y); ct.line_to (p2_x,p2_y)
				ct.close_path();
				ct.set_source_rgb( 1, 1, 1);
				ct.stroke_preserve();
				ct.set_source_rgb( 1, 1, 1);
				ct.fill();
				
				//recuadra todo el bocadillo incluyendo la boca
				ct.set_source_rgb(0, 0, 0)
				ct.set_line_width(2)
				ct.rectangle(paginas[pag].objetos_activos[i].x,paginas[pag].objetos_activos[i].y,paginas[pag].objetos_activos[i].ancho,paginas[pag].objetos_activos[i].alto)
				ct.stroke()
				
				ct.set_source_rgb(1, 1, 1)
				ct.set_line_width(2)
				ct.move_to (p1_x ,p1_y );ct.line_to (p2_x,p2_y)
				ct.stroke()
				
				ct.set_source_rgb(0, 0, 0)
				ct.set_line_width(2)
				ct.move_to (p1_x ,p1_y ) ;  ct.line_to (bx,by); ct.line_to (p2_x,p2_y);
				ct.stroke()
				
				
				//escribe dentro del bocadillo
				ct.set_source_rgb(0, 0, 0)
				ct.select_font_face("KatamotzIkasi", Cairo.FontSlant.NORMAL, Cairo.FontWeight.NORMAL)
				ct.set_font_size(paginas[pag].objetos_activos[i].tamano_texto)
				px= paginas[pag].objetos_activos[i].x; py= paginas[pag].objetos_activos[i].y
				if ultimo_de_lista(paginas[pag].objetos_activos[i].texto)>=0
					for var n=0 to ultimo_de_lista(paginas[pag].objetos_activos[i].texto)
						ct.move_to(px+5, py+paginas[pag].objetos_activos[i].tamano_texto+n*paginas[pag].objetos_activos[i].tamano_texto)
						ct.show_text (paginas[pag].objetos_activos[i].texto[n])
						ct.stroke()


			if paginas[pag].objetos_activos[i].tipo == "Borobilhitz"	
				// rellena una elipse 		
				ct.save()
				ct.set_source_rgb( 1, 1, 1);
				ct.translate(paginas[pag].objetos_activos[i].x+  paginas[pag].objetos_activos[i].ancho/2,
				paginas[pag].objetos_activos[i].y+  paginas[pag].objetos_activos[i].alto/2)
				var radio=0.0
				if paginas[pag].objetos_activos[i].alto>paginas[pag].objetos_activos[i].ancho
					ct.scale(0.1+(double)1/(paginas[pag].objetos_activos[i].alto/paginas[pag].objetos_activos[i].ancho),1);
					radio=pow( pow(paginas[pag].objetos_activos[i].ancho/2,2)+pow(paginas[pag].objetos_activos[i].alto/2,2),0.52)
				else
					ct.scale(1,0.1+(double)1/(paginas[pag].objetos_activos[i].ancho/paginas[pag].objetos_activos[i].alto));
					radio=pow(pow(paginas[pag].objetos_activos[i].ancho/2,2)+pow(paginas[pag].objetos_activos[i].alto/2,2),0.52)
							
				ct.arc(0,0,radio, 0.0, 2 * 3.14);
				ct.fill()
				ct.restore()
				
				
				// crea el borde  una elipse 		
				ct.save()
				ct.set_source_rgb( 0, 0, 0);
				ct.translate(paginas[pag].objetos_activos[i].x+  paginas[pag].objetos_activos[i].ancho/2,
				paginas[pag].objetos_activos[i].y+  paginas[pag].objetos_activos[i].alto/2)
				radio=0.0
				if paginas[pag].objetos_activos[i].alto>paginas[pag].objetos_activos[i].ancho
					ct.scale(0.10+(double)1/(paginas[pag].objetos_activos[i].alto/paginas[pag].objetos_activos[i].ancho),1);
					radio=pow( pow(paginas[pag].objetos_activos[i].ancho/2,2)+pow(paginas[pag].objetos_activos[i].alto/2,2),0.52)
				
				else
					ct.scale(1,0.10+(double)1/(paginas[pag].objetos_activos[i].ancho/paginas[pag].objetos_activos[i].alto));
					radio=pow(pow(paginas[pag].objetos_activos[i].ancho/2,2)+pow(paginas[pag].objetos_activos[i].alto/2,2),0.52)				
				ct.arc(0,0,radio, 0.0, 2 * 3.14);
				ct.stroke()
				ct.restore()
				
				var p1_y=0 ; var p2_y=0; var p1_x=0; var p2_x=0
				calcula_boca(pag,i,ref p1_y , ref p2_y , ref p1_x , ref p2_x)
				var bx= paginas[pag].objetos_activos[i].boca_x;var by= paginas[pag].objetos_activos[i].boca_y
				var px= paginas[pag].objetos_activos[i].x; var py= paginas[pag].objetos_activos[i].y
				
				ct.move_to (p1_x ,p1_y ) ;  ct.line_to (bx,by); ct.line_to (p2_x,p2_y); ct.line_to (p1_x,p1_y)
				ct.close_path();
				ct.set_source_rgb( 1, 1, 1);
				ct.stroke_preserve();
				ct.set_source_rgb( 1, 1, 1);
				ct.fill()
				
				ct.set_source_rgb(1, 1, 1)
				ct.set_line_width(2)
				ct.move_to (p1_x ,p1_y );ct.line_to (p2_x,p2_y)
				ct.stroke()
				
				ct.set_source_rgb(0, 0, 0)
				ct.set_line_width(2)
				ct.move_to (p1_x ,p1_y ) ;  ct.line_to (bx,by); ct.line_to (p2_x,p2_y);
				ct.stroke()
				
				
				//escribe dentro del bocadillo
				ct.set_source_rgb(0, 0, 0)
				ct.select_font_face("KatamotzIkasi", Cairo.FontSlant.NORMAL, Cairo.FontWeight.NORMAL)
				ct.set_font_size(paginas[pag].objetos_activos[i].tamano_texto)
				px= paginas[pag].objetos_activos[i].x; py= paginas[pag].objetos_activos[i].y
				if ultimo_de_lista(paginas[pag].objetos_activos[i].texto)>=0
					for var n=0 to ultimo_de_lista(paginas[pag].objetos_activos[i].texto)
						ct.move_to(px+5, py+paginas[pag].objetos_activos[i].tamano_texto+n*paginas[pag].objetos_activos[i].tamano_texto)
						ct.show_text (paginas[pag].objetos_activos[i].texto[n])
						ct.stroke()
			
			
			if paginas[pag].objetos_activos[i].tipo=="Borobilpentsa"
					
				
				//var bx= paginas[pag].objetos_activos[i].boca_x;	var by= paginas[pag].objetos_activos[i].boca_y
				var px= paginas[pag].objetos_activos[i].x;		var py= paginas[pag].objetos_activos[i].y
				
				// llamando a una funcion para despejar la funcion de tanto calculo
				var p1_x=0 ; var p1_y=0; var p2_x=0; var p2_y=0; var p3_x=0; var p3_y=0
				var r1=0; var r2=0; var r3=0;
				calcula_boca_pentsa(pag,i,10,ref r1,ref p1_x , ref p1_y ,ref r2, ref p2_x , ref p2_y,ref r3,ref p3_x , ref p3_y)
				ct.arc(p1_x ,p1_y ,10, 0.0, 2 * 3.14);
				ct.stroke()
				
				ct.set_source_rgb( 1, 1, 1);
				ct.arc(p1_x ,p1_y ,r1, 0.0, 2 * 3.14);
				ct.fill()
				ct.set_source_rgb( 0, 0, 0);
				ct.arc(p1_x ,p1_y ,r1, 0.0, 2 * 3.14);
				ct.stroke()
				
				ct.set_source_rgb( 1, 1, 1);
				ct.arc(p2_x ,p2_y ,r2, 0.0, 2 * 3.14);
				ct.fill()
				
				ct.set_source_rgb( 0, 0, 0);
				ct.arc(p2_x ,p2_y ,r2, 0.0, 2 * 3.14);
				ct.stroke()
				
				ct.set_source_rgb( 1, 1, 1);
				ct.arc(p3_x ,p3_y ,r3, 0.0, 2 * 3.14);
				ct.fill()
				
				ct.set_source_rgb( 0, 0, 0);
				ct.arc(p3_x ,p3_y ,r3, 0.0, 2 * 3.14);
				ct.stroke()
				
				// rellena una elipse 		
				ct.save()
				ct.set_source_rgb( 1, 1, 1);
				ct.translate(paginas[pag].objetos_activos[i].x+  paginas[pag].objetos_activos[i].ancho/2,
				paginas[pag].objetos_activos[i].y+  paginas[pag].objetos_activos[i].alto/2)
				var radio=0.0
				if paginas[pag].objetos_activos[i].alto>paginas[pag].objetos_activos[i].ancho
					ct.scale(0.1+(double)1/(paginas[pag].objetos_activos[i].alto/paginas[pag].objetos_activos[i].ancho),1);
					radio=pow( pow(paginas[pag].objetos_activos[i].ancho/2,2)+pow(paginas[pag].objetos_activos[i].alto/2,2),0.52)
				
				else
					ct.scale(1,0.1+(double)1/(paginas[pag].objetos_activos[i].ancho/paginas[pag].objetos_activos[i].alto));
					
					radio=pow(pow(paginas[pag].objetos_activos[i].ancho/2,2)+pow(paginas[pag].objetos_activos[i].alto/2,2),0.52)
							
				ct.arc(0,0,radio, 0.0, 2 * 3.14);
				ct.fill()
				ct.restore()
				
				
				// crea el borde  una elipse 		
				ct.save()
				ct.set_source_rgb( 0, 0, 0);
				ct.translate(paginas[pag].objetos_activos[i].x+  paginas[pag].objetos_activos[i].ancho/2,
				paginas[pag].objetos_activos[i].y+  paginas[pag].objetos_activos[i].alto/2)
				radio=0.0
				if paginas[pag].objetos_activos[i].alto>paginas[pag].objetos_activos[i].ancho
					ct.scale(0.1+(double)1/(paginas[pag].objetos_activos[i].alto/paginas[pag].objetos_activos[i].ancho),1);
					radio=pow( pow(paginas[pag].objetos_activos[i].ancho/2,2)+pow(paginas[pag].objetos_activos[i].alto/2,2),0.52)
				
				else
					ct.scale(1,0.1+(double)1/(paginas[pag].objetos_activos[i].ancho/paginas[pag].objetos_activos[i].alto));
					radio=pow(pow(paginas[pag].objetos_activos[i].ancho/2,2)+pow(paginas[pag].objetos_activos[i].alto/2,2),0.52)				
				ct.arc(0,0,radio, 0.0, 2 * 3.14);
				ct.stroke()
				ct.restore()
				
				
				//escribe dentro del bocadillo
				ct.set_source_rgb(0, 0, 0)
				ct.select_font_face("KatamotzIkasi", Cairo.FontSlant.NORMAL, Cairo.FontWeight.NORMAL)
				ct.set_font_size(paginas[pag].objetos_activos[i].tamano_texto)
				px= paginas[pag].objetos_activos[i].x; py= paginas[pag].objetos_activos[i].y
				if ultimo_de_lista(paginas[pag].objetos_activos[i].texto)>=0
					for var n=0 to ultimo_de_lista(paginas[pag].objetos_activos[i].texto)
						ct.move_to(px+5, py+paginas[pag].objetos_activos[i].tamano_texto+n*paginas[pag].objetos_activos[i].tamano_texto)
						ct.show_text (paginas[pag].objetos_activos[i].texto[n])
						ct.stroke()
							
			if paginas[pag].objetos_activos[i].tipo=="Cuadro"
				// haz el recuadro normal
				ct.set_source_rgb(1, 1, 1)
				ct.set_line_width(2)
				ct.rectangle(paginas[pag].objetos_activos[i].x,paginas[pag].objetos_activos[i].y,paginas[pag].objetos_activos[i].ancho,paginas[pag].objetos_activos[i].alto)
				ct.fill()
				
				//escribe dentro del bocadillo
				ct.set_source_rgb(0, 0, 0)
				ct.select_font_face("KatamotzIkasi", Cairo.FontSlant.NORMAL, Cairo.FontWeight.NORMAL)
				ct.set_font_size(paginas[pag].objetos_activos[i].tamano_texto)
				
				var px= paginas[pag].objetos_activos[i].x; var py= paginas[pag].objetos_activos[i].y
				if ultimo_de_lista(paginas[pag].objetos_activos[i].texto)>=0
					for var n=0 to ultimo_de_lista(paginas[pag].objetos_activos[i].texto)
						ct.move_to(px+5, py+paginas[pag].objetos_activos[i].tamano_texto+n*paginas[pag].objetos_activos[i].tamano_texto)
						ct.show_text (paginas[pag].objetos_activos[i].texto[n])
						ct.stroke()
